unit skin;

interface
uses classes,windows;

type tloadproc=function(param:longint;var proc:pointer):boolean;

type tpmod=record
  GetMod:Function(Cmd:Byte):LongInt;
  GetModS:Function(Cmd:Byte):ShortString;
  GetPattern:Function(Patt,Note,Chan,What:Byte):Word;
  GetPatternS:Function(Patt,Note,Chan,What:Byte):ShortString;
  GetInstrS:Function(Cmd:Word):ShortString;
  GetSmplS:Function(Cmd:Word):ShortString;
  GetString:function(param:longint):ShortString;
end;

type tsublist=record
  list:tstrings;
  name:string;
  current:longint;
end;

type tplaylist=record
  sublist:array of tsublist;
  nblist:word;
  nlist:word;
  filename:string;
  oldnlist:word;
end;

type TVis=record
  newplay:procedure;stdcall;
  initdc:procedure(hn:hwnd;tx,ty:longword);stdcall;
  uninitdc:procedure;stdcall;
  dodc:procedure(hn:hwnd;pl:boolean);stdcall;
  cleandc:procedure(hn:hwnd);stdcall;
  initpatt:procedure(hn:hwnd;tx,ty:LongWord);stdcall;
  uninitpatt:procedure;stdcall;
  dopatt:procedure(hn:hwnd;pos:byte;pl:boolean);stdcall;
  cleanpatt:procedure(hn:hwnd);stdcall;
  getvisinfo:function(param:longword):longint;stdcall;
  initgraphs:function(hn1,hn2:hwnd;tx1,ty1,tx2,ty2:LongWord):boolean;
  endgraphs:procedure;
  setupvis:procedure;stdcall;
  setuppattern:procedure;stdcall;
end;

type tgui=record
  sendmessage:Function(msg:longint;param:longint):longint;
  getinfo:Function(what:longint):longint;
  setinfo:Function(what:longint;param:longint):longint;
  getinfos:Function(what:longint):shortstring;
  setplaylist:Procedure(newplist:tplaylist);
  getplaylist:Function:tplaylist;
end;

const
  msg_gui_play=1;
  msg_gui_pause=2;
  msg_gui_stop=3;
  msg_gui_prev=4;
  msg_gui_next=5;
  msg_gui_select=6;
  msg_gui_moveto=7;
  msg_gui_remove=8;
  msg_gui_open=9;
  msg_gui_setup=10;
  msg_gui_info=11;
  msg_gui_playlist=12;
  msg_gui_repeat=13;
  msg_gui_surround=14;
  msg_gui_reverb=15;
  msg_gui_stereo=16;
  msg_gui_ampli=17;
  msg_gui_aampli=18;
  msg_gui_goto=19;
  msg_gui_volume=20;
  msg_gui_quit=21;

  msg_skin_anim=1;
  msg_skin_redraw=2;
  msg_skin_play=3;
  msg_skin_stop=4;
  msg_skin_initgraphs=5;
  msg_skin_endgraphs=6;
  msg_skin_setwindow=7;
  msg_skin_pause=8;
  msg_skin_resume=9;
  msg_skin_entermenu=10;
  msg_skin_leavemenu=11;

  msg_skin_setwindow_enable=1;
  msg_skin_setwindow_disable=2;
  msg_skin_setwindow_bringtotop=3;

  addr_mod_getmod=1;
  addr_mod_getmods=2;
  addr_mod_getpattern=3;
  addr_mod_getpatterns=4;
  addr_mod_getinstrs=5;
  addr_mod_getsmpls=6;
  addr_mod_getstringmod=7;

  addr_vis_newplay=8;
  addr_vis_initdc=9;
  addr_vis_uninitdc=10;
  addr_vis_dodc=11;
  addr_vis_cleandc=12;
  addr_vis_initpatt=13;
  addr_vis_uninitpatt=14;
  addr_vis_dopatt=15;
  addr_vis_cleanpatt=16;
  addr_vis_getvisinfo=17;
  addr_vis_initgraphs=18;
  addr_vis_endgraphs=19;
  addr_vis_setupvis=27;
  addr_vis_setuppattern=28;


  addr_gui_sendmessage=21;
  addr_gui_getinfo=22;
  addr_gui_getinfos=23;
  addr_gui_setplaylist=24;
  addr_gui_getplaylist=25;
  addr_gui_setinfo=26;

  get_gui_status_plistversion=1;
  get_gui_status_modposition=2;
  get_gui_setup_freq=3;
  get_gui_setup_stereo=4;
  get_gui_setup_b16=5;
  get_gui_setup_device=6;
  get_gui_setup_sepastereo=7;
  get_gui_setup_ampli=8;
  get_gui_setup_devicename=9;
  get_gui_setup_freqconv=10;
  get_gui_setup_devices=11;
  get_gui_setup_reverb=12;
  get_gui_setup_surround=13;
  get_gui_setup_autoampli=14;
  get_gui_setup_nmodloop=15;
  get_gui_setup_replay=16;
  get_gui_setup_priority=17;
  get_gui_setup_interpolation=18;
  get_gui_setup_tickremove=19;
  get_gui_setup_taillebuffer=20;
  get_gui_setup_nbuffers=21;
  get_gui_setup_sature=22;
  get_gui_setup_volume=23;
  get_gui_setup_pitch=24;
  get_gui_setup_speed=25;
  get_gui_setup_prebuff=26;
  get_gui_setup_copyonmove=27;
  get_gui_setup_deleteonremove=28;
  get_gui_status_isplaying=29;
  get_gui_status_ispause=30;
  get_gui_status_sature=31;
  get_gui_status_insetup=32;
  get_gui_setup_delnb=33;
  get_gui_setup_deldelay=34;
  get_gui_setup_delint=35;
  get_gui_setup_surnb=36;
  get_gui_setup_surdelay=37;
  get_gui_setup_surint=38;

  set_gui_setup_freq=1;
  set_gui_setup_stereo=2;
  set_gui_setup_b16=3;
  set_gui_setup_device=4;
  set_gui_setup_sepastereo=5;
  set_gui_setup_ampli=6;
  set_gui_setup_reverb=7;
  set_gui_setup_surround=8;
  set_gui_setup_autoampli=9;
  set_gui_setup_nmodloop=10;
  set_gui_setup_priority=11;
  set_gui_setup_interpolation=12;
  set_gui_setup_tickremove=13;
  set_gui_setup_taillebuffer=14;
  set_gui_setup_nbuffers=15;
  set_gui_setup_sature=16;
  set_gui_setup_volume=17;
  set_gui_setup_pitch=18;
  set_gui_setup_speed=19;
  set_gui_setup_prebuff=20;
  set_gui_setup_copyonmove=21;
  set_gui_setup_deleteonremove=22;
  set_gui_setup_delnb=23;
  set_gui_setup_deldelay=24;
  set_gui_setup_delint=25;
  set_gui_setup_surnb=26;
  set_gui_setup_surdelay=27;
  set_gui_setup_surint=28;

  get_gui_currentfilename=1;
  get_gui_skindirectory=2;
  get_gui_visfilename=3;
  get_gui_skinfilename=4;
  get_gui_pmpversion=5;


  get_mod_moddirectory=1;

  get_vis_nbchan=1;
  get_vis_pmpversion=2;

  get_skin_pmpversion=1;



var pmod:tpmod;
    gui:tgui;
    vis:tvis;

procedure loadallstuff(loadproc:tloadproc);

implementation

procedure loadallstuff(loadproc:tloadproc);
var pnt:pointer;
begin
  loadproc(addr_mod_getmod,pnt);@pmod.getmod:=pnt;
  loadproc(addr_mod_getmods,pnt);@pmod.getmods:=pnt;
  loadproc(addr_mod_getpattern,pnt);@pmod.getpattern:=pnt;
  loadproc(addr_mod_getpatterns,pnt);@pmod.getpatterns:=pnt;
  loadproc(addr_mod_getinstrs,pnt);@pmod.getinstrs:=pnt;
  loadproc(addr_mod_getsmpls,pnt);@pmod.getsmpls:=pnt;
  loadproc(addr_mod_getstringmod,pnt);@pmod.getstring:=pnt;

  loadproc(addr_vis_newplay,pnt);@vis.newplay:=pnt;
  loadproc(addr_vis_initdc,pnt);@vis.initdc:=pnt;
  loadproc(addr_vis_uninitdc,pnt);@vis.uninitdc:=pnt;
  loadproc(addr_vis_dodc,pnt);@vis.dodc:=pnt;
  loadproc(addr_vis_cleandc,pnt);@vis.cleandc:=pnt;
  loadproc(addr_vis_initpatt,pnt);@vis.initpatt:=pnt;
  loadproc(addr_vis_uninitpatt,pnt);@vis.uninitpatt:=pnt;
  loadproc(addr_vis_dopatt,pnt);@vis.dopatt:=pnt;
  loadproc(addr_vis_cleanpatt,pnt);@vis.cleanpatt:=pnt;
  loadproc(addr_vis_getvisinfo,pnt);@vis.getvisinfo:=pnt;
  loadproc(addr_vis_initgraphs,pnt);@vis.initgraphs:=pnt;
  loadproc(addr_vis_endgraphs,pnt);@vis.endgraphs:=pnt;
  loadproc(addr_vis_setupvis,pnt);@vis.setupvis:=pnt;
  loadproc(addr_vis_setuppattern,pnt);@vis.setuppattern:=pnt;

  loadproc(addr_gui_sendmessage,pnt);@gui.sendmessage:=pnt;
  loadproc(addr_gui_getinfo,pnt);@gui.getinfo:=pnt;
  loadproc(addr_gui_setinfo,pnt);@gui.setinfo:=pnt;
  loadproc(addr_gui_getinfos,pnt);@gui.getinfos:=pnt;
  loadproc(addr_gui_setplaylist,pnt);@gui.setplaylist:=pnt;
  loadproc(addr_gui_getplaylist,pnt);@gui.getplaylist:=pnt;
end;
end.
