library baseskin;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  Forms, stdctrls,skin;

Type TMyForm=Record
  Form:TForm;
  Play,Stop,Prev,Next,Setup:TButton;
  Name:TLabel;
End;

Var MyForm:TMyForm;

Var InfoStr:String;
Const Version=1 SHL 16+7;


Function SkSendMessage(msg:longint;param:longint):LongInt;stdcall;
begin
  sksendmessage:=0;
  case msg of
    msg_skin_redraw:begin
      myform.name.caption:=gui.getinfos(get_gui_currentfilename);
    end;
    msg_skin_setwindow:begin
      case param of
        msg_skin_setwindow_enable:myform.form.enabled:=true;
        msg_skin_setwindow_disable:myform.form.enabled:=false;
        msg_skin_setwindow_bringtotop:if myform.form.enabled then myform.form.setfocus;
      end;
    end;

  end;
end;

procedure SkEnd;stdcall;
begin
  with myform do begin
    form.hide;
    form.release;
  end;
end;

function SkGetInfo(param:longword):longint;stdcall;
begin
  skgetinfo:=0;
  case param of
    Get_Skin_PMPVersion:skgetinfo:=version;
  end;
end;

procedure SkMsg(txt:shortstring;glob:boolean);stdcall;
begin
end;

procedure fin(Sender: TObject; var CanClose: Boolean);
begin
  gui.sendmessage(msg_gui_stop,0);
  gui.sendmessage(msg_gui_quit,1);
end;

procedure onplay(Sender:TObject);
begin
  gui.sendmessage(msg_gui_play,0);
end;

procedure onstop(Sender:TObject);
begin
  gui.sendmessage(msg_gui_stop,0);
end;

procedure onprev(Sender:TObject);
begin
  gui.sendmessage(msg_gui_prev,0);
end;

procedure onnext(Sender:TObject);
begin
  gui.sendmessage(msg_gui_next,0);
end;

procedure onsetup(Sender:TObject);
begin
  gui.sendmessage(msg_gui_setup,0);
end;

procedure create_my_window;
begin
  with myform do begin
    Form:=TForm.Create(Nil);
    Form.Position:=podesktopcenter;
    Form.Width:=270;
    Form.Height:=80;
    Form.borderStyle:=bsSingle;
    Form.BorderIcons:=[biSystemMenu,biMinimize];
    Form.Caption:='Plouf''s ModPlayer';
    @Form.OnCloseQuery:=@Fin;

    Play:=TButton.Create(Form);
    Play.Parent:=Form;
    Play.Left:=10;
    Play.Top:=10;
    Play.Width:=45;
    Play.Height:=20;
    Play.Caption:='Play';
    @Play.OnClick:=@OnPlay;

    Stop:=TButton.Create(Form);
    Stop.Parent:=Form;
    Stop.Left:=60;
    Stop.Top:=10;
    Stop.Width:=45;
    Stop.Height:=20;
    Stop.Caption:='Stop';
    @Stop.OnClick:=@OnStop;

    Prev:=TButton.Create(Form);
    Prev.Parent:=Form;
    Prev.Left:=110;
    Prev.Top:=10;
    Prev.Width:=45;
    Prev.Height:=20;
    Prev.Caption:='Prev';
    @Prev.OnClick:=@OnPrev;

    Next:=TButton.Create(Form);
    Next.Parent:=Form;
    Next.Left:=160;
    Next.Top:=10;
    Next.Width:=45;
    Next.Height:=20;
    Next.Caption:='Next';
    @Next.OnClick:=@OnNext;

    Setup:=TButton.Create(Form);
    Setup.Parent:=Form;
    Setup.Left:=210;
    Setup.Top:=10;
    Setup.Width:=45;
    Setup.Height:=20;
    Setup.Caption:='Setup';
    @Setup.OnClick:=@OnSetup;

    Name:=TLabel.Create(Form);
    Name.Parent:=Form;
    Name.Left:=10;
    Name.Top:=35;
    Name.Width:=250;
    Name.Height:=8;

  end;
end;

procedure SkInit(loadproc:tloadproc);stdcall;
begin
  loadallstuff(loadproc);
  create_my_window;
  myform.form.show;
end;

function GetInfoStr:pstring;stdcall;
begin
  getinfostr:=@infostr;
end;


exports
  SkSendMessage index 1,
  SkMsg index 2,
  SkInit index 3,
  SkEnd index 4,
  SkGetInfo index 5,
  GetInfoStr index 6;

begin
  infostr:='Simple skin example';
end.
