{
  Player Wave par Philippe Detournay alias Plouf
  Juin 1999
  Programme conu comme aide au tutoriel pour la programmation DSP
  Des questions, des points peu clairs? mail : plouf@skynet.be

  Teste sous SBPro, ne dcode pour ainsi dire rien de l'en-tte
  du wav, suppose par consquent que le fichier est en 8bit-mono.
}

Program Wav;
Uses Dos,Crt;

Const TailleBuffer=4096;

Var Freq:Word;
    Channel, IRQ, BasePort:Integer;
    Fle:File;
    TimeConst, IntVal, PgPort, AddPort, LenPort, ModeReg:Byte;
    Tot:LongInt;
    Tmp:Integer;
    Ps:Byte;
    TxT:String;
    Blaster:String;
    BaseTot:LongInt;
    OldInt:Pointer;
    Of1,Of2:Pointer;
    Buffer:Array[1..TailleBuffer*2] Of Byte;
    Adr:LongInt;

{Envoie un octet vers le DSP}
Procedure WriteDsp(Oct:Byte);
Begin
  Repeat Until (Port[BasePort+12] AND 128)=0;
  Port[BasePort+12]:=Oct;
End;

{Lit un octet du DSP}
Function ReadDsp:Byte;
Begin
  Repeat Until (Port[BasePort+14] AND 128)=1;
  ReadDsp:=Port[BasePort+10];
End;

{Reset le DSP}
Function ResetDsp:Boolean;
Var Try:Word;
Begin
  Port[BasePort+6]:=1;
  Delay(100);
  Port[BasePort+6]:=0;
  Try:=65535;
  Repeat Dec(Try) Until ((Port[BasePort+$e] SHR 7=1) AND (Port[BasePort+$a]=$aa)) Or (Try=0);
  If Try>0 Then ResetDsp:=True Else ResetDsp:=False;
End;

Procedure Stop;
Begin
  ResetDsp;
  {DMA Stop}
  WriteDsp($d0);
  {Coupure du haut-parleur}
  WriteDsp($d3);

  {Coupure de l'IRQ}
  Port[$21]:=Port[$21] Or (1 SHL IRQ);
  SetIntVec(IntVal, OldInt);
  Close(Fle);
End;

Procedure Lire;
Var iTmp:Pointer;
    Count:Word;
Begin
  BlockRead(Fle,Of1^,TailleBuffer,Count);
  If Count<TailleBuffer Then Begin
    {On boucle le fichier}
    Tot:=BaseTot;
    Seek(Fle,44);
    BlockRead(Fle,Ptr(Seg(Of1^),Ofs(Of1^)+Count)^,TailleBuffer-Count,Count);
  End;
  Dec(Tot,Count);
  {Swap les deux pointeurs}
  iTmp:=Of1;
  Of1:=Of2;
  Of2:=iTmp;
End;

Procedure Play(Flags, CS, IP, AX, BX, CX, DX, SI, DI, DS, ES, BP: Word);
Interrupt;
Var iBid:Byte;
Begin
  {Rpond  la carte}
  iBid:=Port[BasePort+14];
  Lire;
  {Rpond au controleur IRQ}
  Port[$20]:=$20;
End;

Begin
  ClrScr;

  Of1:=@Buffer;
  Of2:=Ptr(Seg(Buffer),Ofs(Buffer)+TailleBuffer);

  {Dcode l'environement}
  Blaster:=GetEnv('BLASTER');

  Ps:=Pos('A',Blaster);
  Txt:='$'+Blaster[Ps+1]+Blaster[Ps+2]+Blaster[Ps+3];
  Val(TxT,BasePort,Tmp);

  Ps:=Pos('I',Blaster);
  Txt:=Blaster[Ps+1];
  If Blaster[Ps+2]<>' ' Then Txt:=Txt+Blaster[Ps+2];
  Val(Txt,IRQ,Tmp);

  Txt:='$'+Blaster[Pos('D',Blaster)+1];
  Val(Txt,Channel,Tmp);
  WriteLn('SoundBlaster trouve : ');
  WriteLn('  Port=',BasePort);
  WriteLn('  IRQ=',IRQ);
  WriteLn('  DMA=',Channel);

  WriteLn('Ouverture du fichier et lecture de l''en-tte...  ');
  Assign(Fle,'f:\wav\m8b44\tetsuo.wav');
  Reset(Fle,1);
  BlockRead(Fle,Of1^,44);

  {Frquence et longueur du wav}
  Freq:=MemW[DSeg:Ofs(Of1^)+24];
  Tot:=MemL[DSeg:Ofs(Of1^)+40];
  {Sauve cette valeur, elle nous servira pour le loop du wav}
  BaseTot:=Tot;

  WriteLn('Initialisation et branchement de l''IRQ...  ');
  Case Channel Of
    0:Begin
      PgPort:=$87;
      AddPort:=$0;
      LenPort:=$1;
      ModeReg:=$58;
    End;
    1:Begin
      PgPort:=$83;
      AddPort:=$2;
      LenPort:=$3;
      ModeReg:=$59;
    End;
    2:Begin
      PgPort:=$81;
      AddPort:=$4;
      LenPort:=$5;
      ModeReg:=$5a;
    End;
    3:Begin
      PgPort:=$82;
      AddPort:=$6;
      LenPort:=$7;
      ModeReg:=$5b;
    End;

  End;

  Case IRQ Of
    2:Begin
      IntVal:=$a;
      Port[$21]:=Port[$21] AND 251
    End;
    3:Begin
      IntVal:=$b;
      Port[$21]:=Port[$21] AND 247
    End;
    5:Begin
      IntVal:=$d;
      Port[$21]:=Port[$21] AND 223
    End;
    7:Begin
      IntVal:=$f;
      Port[$21]:=Port[$21] AND 127
    End;

  End;
  {Installe la nouvelle INT}
  GetIntVec(IntVal,OldInt);
  SetIntVec(IntVal,@Play);

  {La frquence pour le DSP}
  TimeConst:=Round(65536-((256000000)/Freq)) SHR 8;

  {Remplit le buffer}
  Lire;
  Lire;
  WriteLn('Reset du DSP et envoi des informations  la carte...  ');

  {On reveille la carte}
  If ResetDsp Then Begin
    {On reveille le DMA}
    {Signalons-lui de quel canal on parle : les deux premiers bits
    pour le canal, le 4eme pour l'ouverture}
    Port[$a]:=Channel+4;
    {Mettons le pointer DMA  0}
    Port[$c]:=0;
    {Et expliquons-lui ce qu'on lui veut}
    Port[$b]:=ModeReg;

    {L'adresse FLAT (Segment*16+Offset)}
    Adr:=Seg(Of1^);
    Adr:=Adr SHL 4+Ofs(Of1^);

    {Et on la lui donne}
    Port[AddPort]:=Adr AND 255;
    Port[AddPort]:=(Adr SHR 8) AND 255;
    Port[PgPort]:=Adr SHR 16;

    {La longueur galement}
    Port[LenPort]:=(TailleBuffer*2-1) AND 255;
    Port[LenPort]:=(TailleBuffer*2-1) SHR 8;

    {Refermons la discussions : 3eme bit  0, 2premiers bits pour le canal}
    Port[$a]:=Channel;

    {Au tour de la carte de nous subir}
    {Branchons les speakers}
    WriteDsp($d1);

    {Commande $40 : le DSP attend le TimeConst}
    WriteDsp($40);
    WriteDsp(TimeConst);

    {Commande $48 : le DSP attend la longueur}
    WriteDsp($48);
    WriteDsp((TailleBuffer) AND 255);
    WriteDsp((TailleBuffer) SHR 8);
    {Commande $90 : mode autoinitialise output : go!}
    WriteDsp($90);

    WriteLn('C''est partit!');
    WriteLn('Joue en ',Freq,'Hz, 8bits, Mono');

    Repeat Until KeyPressed;
    Stop;
  End Else Begin
    WriteLn('Echec : reset du DSP impossible');
    Repeat Until KeyPressed;
  End;
End.
