{Ce fichier est un fichier include de Modunit.Pas, il
 contient les routines respectives de chacun des effets
 des modules. Chaque routine reoit C le canal, et Param
 la paramtre de cet effet. Pour rappel : MType est le
 type du module : 1=Mod, 2=S3m, 3=Xm}

Procedure Speed(C,Param:Byte);
Begin
  If D.Tick=0 Then Begin
    ReInit(C);
    Case MType Of
      1,3:Begin
        If Param<32 Then Begin
          If Param<>0 Then D.Speed:=Param;
        End Else Begin
          D.Bpm:=Param;
          Dec(D.CurSend,D.OpTicks);
          D.OpTicks:=Round(MixSpeed/(D.Bpm*2/5*E.Speed)*256);
          Inc(D.CurSend,D.OpTicks);
        End;
      End;
      2:Begin
        If Param<>0 Then D.Speed:=Param;
      End;
    End;
  End;
End;

Procedure Jump(C,Param:Byte);
Begin
  If D.Tick=0 Then ReInit(C);
  If D.Tick=D.Speed-1 Then Begin
    D.IsAskJump:=True;
    D.IsWaitJump:=True;
    D.NextPos:=Param;
    If D.NextPos>=D.Max Then D.NextPos:=D.Max-1;
    D.NextPattern:=PatPos[D.NextPos];
    D.NextNote:=1;
  End;
End;

Procedure Break(C,Param:Byte);
Var T1,T2:Byte;
Begin
  If D.Tick=0 Then ReInit(C);
  If D.Tick=D.Speed-1 Then Begin
    D.IsWaitJump:=True;
    If Not D.IsAskJump Then Begin
      D.NextPos:=D.Pos+1;
      If D.NextPos=D.Max Then D.NextPos:=0;
      D.NextPattern:=PatPos[D.NextPos];
    End;
    T1:=Param SHR 4;
    T2:=Param AND $f;
    D.NextNote:=T1*10+T2+1;
    If D.NextNote>PRow[D.NextPattern] Then D.NextNote:=1;
  End;
End;

Procedure VolSlide(C,Param:Byte);
Var T1,T2:Byte;
Begin
  If Not Joue Then Exit;
  If MType=1 Then D.LastVS[C]:=0;
  If Param<>0 Then D.LastVS[C]:=Param;
  T1:=D.LastVS[C] SHR 4;
  T2:=D.LastVS[C] AND $f;
  If D.Tick=0 Then ReInit(C);
  Case MType Of
    1,3:Begin
      If D.Tick<>0 Then Begin
        If (T1>0) AND (T2=0) Then Begin
          If Chan[C].Volume+T1<=64 Then Inc(Chan[C].Volume,T1) Else Chan[C].Volume:=64;
        End;
        If (T1=0) AND (T2>0) Then Begin
          If Chan[C].Volume>=T2 Then Dec(Chan[C].Volume,T2) Else Chan[C].Volume:=0;
        End;
      End;
    End;
    2:Begin
      If D.Tick<>0 Then Begin
        If (T1>0) AND (T2=0) Then Begin
          If Chan[C].Volume+T1<=64 Then Chan[C].Volume:=D.GlobVol[C]+T1 Else Chan[C].Volume:=64;
        End;
        If (T1=0) AND (T2>0) Then Begin
          If Chan[C].Volume>=T2 Then Chan[C].Volume:=D.GlobVol[C]-T2 Else Chan[C].Volume:=0;
        End;
      End Else Begin
        If T2=15 Then Begin
          If T1<>0 Then Begin
            If Chan[C].Volume+T1<=64 Then Chan[C].Volume:=D.GlobVol[C]+T1 Else Chan[C].Volume:=64;
          End Else Begin
            If Chan[C].Volume>=15 Then Chan[C].Volume:=D.GlobVol[C]-15 Else Chan[C].Volume:=0;
          End;
        End;
        If T1=15 Then Begin
          If T2<>0 Then Begin
            If Chan[C].Volume>=T2 Then Chan[C].Volume:=D.GlobVol[C]-T2 Else Chan[C].Volume:=0;
          End Else Begin
            If Chan[C].Volume+15<=64 Then Chan[C].Volume:=D.GlobVol[C]+15 Else Chan[C].Volume:=64;
          End;
        End;
      End;
    End;
  End;
  D.GlobVol[C]:=Chan[C].Volume;
End;

Procedure PortDown(C,Param:Byte);
Var T1,T2:Byte;

Begin
  If Not Joue Then Exit;
  If Param<>0 Then Begin
    D.LastSD[C]:=Param;
    D.LastSU[C]:=Param;
  End;
  T1:=D.LastSD[C] SHR 4;
  T2:=D.LastSD[C] AND $f;
  Case MType Of
    1,3:Begin
      If D.Tick=0 Then ReInit(C);
      If (D.Tick<>0) Then Begin
        Inc(Chan[C].Period,D.LastSD[C]*4);
        CalcPer(C);
        D.GlobPer[C]:=Chan[C].Period;
      End;
    End;
    2:Begin
      If T1=15 Then Begin
        If D.Tick=0 Then Begin
          ReInit(C);
          Inc(Chan[C].Period,T2);
          CalcPer(C);
        End;
      End;
      If T1=14 Then Begin
        If D.Tick=0 Then Begin
          ReInit(C);
          Inc(Chan[C].Period,T2);
          CalcPer(C);
        End;
      End;
      If T1<14 Then Begin
        If D.Tick=0 Then Begin
          ReInit(C);
        End Else Begin
          Inc(Chan[C].Period,D.LastSD[C]*4);
          CalcPer(C);
        End;
      End;
      D.GlobPer[C]:=Chan[C].Period;
    End;
  End;
End;

Procedure PortUp(C,Param:Byte);
Var T1,T2:Byte;
Begin
  If Not Joue Then Exit;
  If Param<>0 Then Begin
    D.LastSD[C]:=Param;
    D.LastSU[C]:=Param;
  End;
  T1:=D.LastSU[C] SHR 4;
  T2:=D.LastSU[C] AND $f;
  Case MType Of
    1,3:Begin
      If D.Tick=0 Then ReInit(C);
      If D.Tick<>0 Then Begin
        If Chan[C].Period>D.LastSU[C]*4 Then Dec(Chan[C].Period,D.LastSU[C]*4) Else Chan[C].Used:=False;
        CalcPer(C);
        D.GlobPer[C]:=Chan[C].Period;
      End;
    End;
    2:Begin
      If T1=15 Then Begin
        If D.Tick=0 Then Begin
          ReInit(C);
          If Chan[C].Period>T2 Then Dec(Chan[C].Period,T2) Else Chan[C].Used:=False;
          CalcPer(C);
        End;
      End;
      If T1=14 Then Begin
        If D.Tick=0 Then ReInit(C);
        If Chan[C].Period>T2 Then Dec(Chan[C].Period,T2) Else Chan[C].Period:=1;
        CalcPer(C);
      End;
      If T1<14 Then Begin
        If D.Tick=0 Then Begin
          ReInit(C);
       End Else Begin
          If Chan[C].Period>D.LastSU[C]*4 Then Dec(Chan[C].Period,D.LastSU[C]*4) Else Chan[C].Used:=False;
          CalcPer(C);
        End;
      End;
      D.GlobPer[C]:=Chan[C].Period;
    End;
  End;
End;

Procedure PortNote(C,Param:Byte);
Var Mult:Single;
    Note,Octave:Byte;
    Fine:ShortInt;
    V:Word;
    Next:Double;
    I:Byte;
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then Begin
    ReInit(C);
    Case MType Of
      1:Begin
        If Param<>0 Then D.LPS[C]:=Param*4;
        If Pattern[D.Pattern,C]^.Period[D.Note]<>0 Then Begin
          D.ShouldPort[C]:=Chan[C].Period;
          D.NTP[C]:=Pattern[D.Pattern,C]^.Period[D.Note]*4;
        End;
      End;
      2:Begin
        If Param<>0 Then D.LPS[C]:=Param*4;
        If Pattern[D.Pattern,C]^.Period[D.Note]<>0 Then Begin
          D.ShouldPort[C]:=Chan[C].Period;
          Note:=Pattern[D.Pattern,C]^.Period[D.Note] AND $f;
          Octave:=(Pattern[D.Pattern,C]^.Period[D.Note] AND $ff) SHR 4;

          Mult:=0;
          If Smpl[Chan[C].Sample].Amiga<>0 Then Begin
            Mult:=16*(Period[Note]/(1 SHL Octave));
            Mult:=Mult/Smpl[Chan[C].Sample].Amiga*8363;
          End;
          D.NTP[C]:=Round(Mult);
        End;
      End;
      3:Begin
        V:=Pattern[D.Pattern,C]^.Period[D.Note];
        If V=97 Then V:=0;
        If Param<>0 Then D.LPS[C]:=Param*4;
        Fine:=Smpl[Chan[C].Sample].Fine;
        If V<>0 Then Begin
          D.ShouldPort[C]:=Chan[C].Period;
          Note:=V;
          Inc(Note,Smpl[Chan[C].Sample].Rel);
          Case FreqTable Of
            0:Begin
              Mult:=PeriodTab[(Note MOD 12)*8 + Fine Div 16]*(1-Frac(Fine/16));
              Mult:=Mult+PeriodTab[(Note MOD 12)*8 + Fine Div 16]*(Frac(Fine/16));
              Mult:=16*Mult/(1 Shl (Note DIV 12));
              D.NTP[C]:=Round(Mult*2);
            End;
            1:Begin
              Dec(Note);
              D.NTP[C]:=Round(7680-Note*64-Fine/2);
            End;
          End;
        End;
      End;
    End;
  End;
  If D.Tick<>0 Then Begin
    If D.Gliss[C]=0 Then Begin
      If Chan[C].Period<D.NTP[C] Then Begin
        Inc(Chan[C].Period,D.LPS[C]);
        If Chan[C].Period>D.NTP[C] Then Chan[C].Period:=D.NTP[C];
      End;
      If Chan[C].Period>D.NTP[C] Then Begin
        If Chan[C].Period>D.LPS[C] Then Dec(Chan[C].Period,D.LPS[C]) Else Chan[C].Period:=1;
        If Chan[C].Period<D.NTP[C] Then Chan[C].Period:=D.NTP[C];
      End;
    End else Begin
      Next:=Chan[C].Period;
      If D.ShouldPort[C]<D.NTP[C] Then Begin
        For I:=1 To 1 Do Next:=Next*(1.059463094359);
        Inc(D.ShouldPort[C],D.LPS[C]);
        If D.ShouldPort[C]>D.NTP[C] Then D.ShouldPort[C]:=D.NTP[C];
        If D.ShouldPort[C]>Next Then Chan[C].Period:=Round(Next);
      End;
      If D.ShouldPort[C]>D.NTP[C] Then Begin
        For I:=1 To 1 Do Next:=Next/(1.059463094359);
        If D.ShouldPort[C]>D.LPS[C] Then Dec(D.ShouldPort[C],D.LPS[C]) Else D.ShouldPort[C]:=1;
        If D.ShouldPort[C]<D.NTP[C] Then D.ShouldPort[C]:=D.NTP[C];
        If D.ShouldPort[C]<Next Then Chan[C].Period:=Round(Next);
      End;
    End;

    CalcPer(C);
    D.GlobPer[C]:=Chan[C].Period;
  End;

End;

Procedure Vibrato(C,Param:Byte);
Var T1,T2:Byte;
    Delta:Integer;
Begin
  If Not Joue Then Exit;
  Case MType Of
    1:Begin
      If D.Tick=0 Then Begin
        If Param<>0 Then D.LastVib[C]:=Param;
        If (D.LastEffCmd[C]<>$4) AND (D.LastEffCmd[C]<>$6) Then Begin
          ReInit(C);
          If (D.VibType[C] And 4)=0 Then Begin
            D.VibPos[C]:=0;
            D.VibNeg[C]:=0;
          End;
        End;
      End Else Begin
        T1:=D.LastVib[C] SHR 4;
        If T1=0 Then T1:=D.LastVibV[C] Else D.LastVibV[C]:=T1;
        T2:=D.LastVib[C] AND $f;
        If T2=0 Then T2:=D.LastVibD[C] Else D.LastVibD[C]:=T2;

        Delta:=0;
        Case D.VibType[C] And 3 Of
          0:Begin Delta:=T2*VibTab1[D.VibPos[C]] Div 32;If D.VibNeg[C]=1 Then Delta:=-Delta;End;
          1:Begin Delta:=T2*(VibTab2[D.VibPos[C]]) Div 32;If D.VibNeg[C]=1 Then Delta:=Delta-128;End;
          2:Begin Delta:=T2*256 Div 32;If D.VibNeg[C]=1 Then Delta:=-Delta;End;
          3:Delta:=Random(256);
        End;
        Chan[C].Period:=D.GlobPer[C]+Delta;

        Inc(D.VibPos[C],T1);
        If D.VibPos[C]>31 Then Begin
          D.VibNeg[C]:=1-D.VibNeg[C];
          Dec(D.VibPos[C],32);
        End;
        CalcPer(C);
      End;
    End;
    2:Begin
      If D.Tick=0 Then Begin
        If Param<>0 Then D.LastVib[C]:=Param;
        If (D.LastEffCmd[C]<>8) AND (D.LastEffCmd[C]<>11) Then Begin
          ReInit(C);
          If (D.VibType[C] And 4)=0 Then Begin
            D.VibPos[C]:=0;
            D.VibNeg[C]:=0;
          End;
        End;
      End Else Begin
        T1:=D.LastVib[C] SHR 4;
        If T1=0 Then T1:=D.LastVibV[C] Else D.LastVibV[C]:=T1;
        T2:=D.LastVib[C] AND $f;
        If T2=0 Then T2:=D.LastVibD[C] Else D.LastVibD[C]:=T2;

        Delta:=0;
        Case D.VibType[C] And 3 Of
          0:Begin Delta:=T2*VibTab1[D.VibPos[C]] Div 32;If D.VibNeg[C]=1 Then Delta:=-Delta;End;
          1:Begin Delta:=T2*(VibTab2[D.VibPos[C]]) Div 32;If D.VibNeg[C]=1 Then Delta:=Delta-128;End;
          2:Begin Delta:=T2*256 Div 32;If D.VibNeg[C]=1 Then Delta:=-Delta;End;
          3:Delta:=Random(256);
        End;
        Chan[C].Period:=D.GlobPer[C]+Delta;

        Inc(D.VibPos[C],T1);
        If D.VibPos[C]>31 Then Begin
          D.VibNeg[C]:=1-D.VibNeg[C];
          Dec(D.VibPos[C],32);
        End;
        CalcPer(C);
      End;
    End;
    3:Begin
      If D.Tick=0 Then Begin
        If Param<>0 Then D.LastVib[C]:=Param;
        If (D.LastEffCmd[C]<>$4) AND (D.LastEffCmd[C]<>$6) AND ((D.LastVolCmd[C] AND $f0)<>$b0) Then Begin
          ReInit(C);
          If (D.VibType[C] And 4)=0 Then Begin
            D.VibPos[C]:=0;
            D.VibNeg[C]:=0;
          End;
        End;
      End Else Begin
        T1:=D.LastVib[C] SHR 4;
        If T1=0 Then T1:=D.LastVibV[C] Else D.LastVibV[C]:=T1;
        T2:=D.LastVib[C] AND $f;
        If T2=0 Then T2:=D.LastVibD[C] Else D.LastVibD[C]:=T2;

        Delta:=0;
        Case D.VibType[C] And 3 Of
          0:Begin Delta:=T2*VibTab1[D.VibPos[C]] Div 32;If D.VibNeg[C]=1 Then Delta:=-Delta;End;
          1:Begin Delta:=T2*(VibTab2[D.VibPos[C]]) Div 32;If D.VibNeg[C]=1 Then Delta:=Delta-128;End;
          2:Begin Delta:=T2*256 Div 32;If D.VibNeg[C]=1 Then Delta:=-Delta;End;
          3:Delta:=Random(256);
        End;

        Chan[C].Period:=D.GlobPer[C]+Delta;

        Inc(D.VibPos[C],T1);
        If D.VibPos[C]>31 Then Begin
          D.VibNeg[C]:=1-D.VibNeg[C];
          Dec(D.VibPos[C],32);
        End;
        CalcPer(C);
      End;
    End;
  End;
End;

Procedure Tremolo(C,Param:Byte);
Var T1,T2:Byte;
    Delta:Integer;
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then Begin
    If Param<>0 Then D.LastTrem[C]:=Param;
    If (D.LastEffCmd[C]<>Eff_Tremolo) Then Begin
      ReInit(C);
      If (D.TremType[C] And 4)=0 Then Begin
        D.TremPos[C]:=0;
        D.TremNeg[C]:=0;
      End;
    End;
  End Else Begin
    T1:=D.LastTrem[C] SHR 4;
    If T1=0 Then T1:=D.LastTremV[C] Else D.LastTremV[C]:=T1;
    T2:=D.LastTrem[C] AND $f;
    If T2=0 Then T2:=D.LastTremD[C] Else D.LastTremD[C]:=T2;

    Delta:=0;
    Case D.TremType[C] And 3 Of
      0:Begin Delta:=T2*VibTab1[D.TremPos[C]] Div 64;If D.TremNeg[C]=1 Then Delta:=-Delta;End;
      1:Begin Delta:=T2*(VibTab2[D.TremPos[C]]) Div 64;If D.TremNeg[C]=1 Then Delta:=Delta-64;End;
      2:Begin Delta:=T2*256 Div 64;If D.TremNeg[C]=1 Then Delta:=-Delta;End;
      3:Delta:=Random(256);
    End;
    If D.GlobVol[C]+Delta>0 Then Chan[C].Volume:=D.GlobVol[C]+Delta Else Chan[C].Volume:=0;
    If Chan[C].Volume>64 Then Chan[C].Volume:=64;

    Inc(D.TremPos[C],T1);
    If D.TremPos[C]>31 Then Begin
      D.TremNeg[C]:=1-D.TremNeg[C];
      Dec(D.TremPos[C],32);
    End;
  End;
End;

Procedure Tremor(C,Param:Byte);
Var T1,T2:Byte;
Begin
  If Not Joue Then Exit;
  If Param<>0 Then D.LastTre[C]:=Param;
  T1:=Param SHR 4;
  T2:=Param AND $f;
  If T1+T2=0 Then Exit;

  If D.Tick=0 Then ReInit(C);
  If D.Tick MOD (T1+T2)=0 Then Begin
    Chan[C].Volume:=D.GlobVol[C];
  End;
  If D.Tick MOD (T1+T2)=T1 Then Begin
    Chan[C].Volume:=0;
  End;
End;

Procedure Arpeggio(C,Param:Byte);
Var T1,T2:Byte;
    I:Byte;
    Mult:Single;
Begin
  If Not Joue Then Exit;
  If Param<>0 Then D.LastArp[C]:=Param;
  T1:=Param SHR 4;
  T2:=Param AND $f;
  Case MType Of
    1,3:Begin
      If D.Tick=0 Then ReInit(C);
      If Param<>0 Then Begin
        Case D.Tick MOD 3 Of
          0:Begin
            ReInit(C);
          End;
          1:Begin
            Mult:=D.GlobPer[C] Shr 2;
            For I:=1 To T1 Do Mult:=Mult/1.059463094359;
            Chan[C].Period:=Round(Mult*4);
          End;
          2:Begin
            Mult:=D.GlobPer[C] Shr 2;
            For I:=1 To T2 Do Mult:=Mult/1.059463094359;
            Chan[C].Period:=Round(Mult*4);
          End;
        End;
        CalcPer(C);
      End;
    End;
    2:Begin
      Case D.Tick MOD 3 Of
        0:Begin
          ReInit(C);
        End;
        1:Begin
          Mult:=D.GlobPer[C] Shr 2;
          For I:=1 To T1 Do Mult:=Mult/1.059463094359;
          Chan[C].Period:=Round(Mult*4);
        End;
        2:Begin
          Mult:=D.GlobPer[C] Shr 2;
          For I:=1 To T2 Do Mult:=Mult/1.059463094359;
          Chan[C].Period:=Round(Mult*4);
        End;
      End;
      CalcPer(C);
    End;
  End;
End;

Procedure Offset(C,Param:Byte);
Var Cnd:Boolean;
    V:Word;
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then Begin
    V:=Pattern[D.Pattern,C]^.Period[D.Note];
    Cnd:=True;
    If MType=1 Then Cnd:=True;
    If MType=2 Then Cnd:=(V<>0) AND (V<>254);
    If MType=3 Then Cnd:=(V<>0) AND (V<>97);
    If Cnd Then Begin
      ReInit(C);
      Chan[C].Ofs:=Param SHL (Fixed+8)+Deca SHL Fixed;
      With Chan[C] Do Begin
        Case Dir Of
          0:Begin
            If Ofs>=LoopF Then Begin
              Used:=False;
              Ofs:=Deca SHL Fixed;
              V1:=0;
              V2:=0;
            End;
          End;
          1:Begin
            If Ofs>=LoopF Then Begin
              Repeat Dec(Ofs,Decr) Until Ofs<LoopF;
            End;
          End;
          2:Begin
            Inc(Ofs,Speed);
            If Ofs>=LoopF Then Begin
              Dir:=3;
              Repeat Dec(Ofs,Decr) Until Ofs<LoopF;
            End;
          End;
          3:Begin
            Dec(Ofs,Speed);
            If Ofs>=LoopF Then Repeat Dec(Ofs,Decr) Until Ofs<LoopF;
            If Ofs<=LoopD Then Begin
              Dir:=2;
              Inc(Ofs,Speed);
            End;
          End;
        End;
      End;
    End;
  End;
End;

Procedure Retrig(C,Param:Byte);
Var T1,T2:Byte;
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then Begin
    ReInit(C);
  End Else Begin
    If Param<>0 Then D.LastRet[C]:=Param;
    T1:=D.LastRet[C] SHR 4;
    T2:=D.LastRet[C] AND $f;
    If T2=0 Then Exit;
    Case MType Of
      1,3:Begin
        If D.Tick MOD T2=0 Then Begin
          Chan[C].Ofs:=Deca SHL Fixed;
        End;
      End;
      2:Begin
        If D.Tick MOD T2=0 Then Begin
          Chan[C].Ofs:=Deca SHL Fixed;
          Case T1 Of
            $1:If Chan[C].Volume>=1 Then Dec(Chan[C].Volume) Else Chan[C].Volume:=0;
            $2:If Chan[C].Volume>=2 Then Dec(Chan[C].Volume,2) Else Chan[C].Volume:=0;
            $3:If Chan[C].Volume>=4 Then Dec(Chan[C].Volume,4) Else Chan[C].Volume:=0;
            $4:If Chan[C].Volume>=8 Then Dec(Chan[C].Volume,8) Else Chan[C].Volume:=0;
            $5:If Chan[C].Volume>=16 Then Dec(Chan[C].Volume,16) Else Chan[C].Volume:=0;
            $6:Chan[C].Volume:=Chan[C].Volume*2 Div 3;
            $7:Chan[C].Volume:=Chan[C].Volume Div 2;
            $9:Inc(Chan[C].Volume);
            $a:Inc(Chan[C].Volume,2);
            $b:Inc(Chan[C].Volume,4);
            $c:Inc(Chan[C].Volume,8);
            $d:Inc(Chan[C].Volume,16);
            $e:Chan[C].Volume:=Chan[C].Volume*3 Div 2;
            $f:Chan[C].Volume:=Chan[C].Volume*2;
          End;
          If Chan[C].Volume>64 Then Chan[C].Volume:=64;
          D.GlobVol[C]:=Chan[C].Volume;
        End;
      End;
    End;
  End;
End;

Procedure SetFilter(C,Param:Byte);
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then ReInit(C);
End;

Procedure FineTune(C,Param:Byte);
Var T2:Byte;
Begin
  If Not Joue Then Exit;
  T2:=Param AND $f;
  If D.Tick=0 Then Begin
    ReInit(C);
    Case MType Of
      1:Begin
        Smpl[Chan[C].Sample].Amiga:=AmigaTab[(T2+8) MOD 16];
      End;
      2:Begin
        Smpl[Chan[C].Sample].Amiga:=AmigaTab[T2];
      End;
      3:Begin
        Smpl[Chan[C].Sample].Fine:=Param;
      End;
    End;
  End;
End;

Procedure PatLoop(C,Param:Byte);
Var T2:Byte;
Begin
  If D.Tick=0 Then ReInit(C);
  If D.Tick=D.Speed-1 Then Begin
    T2:=Param AND $f;
    If T2=0 Then D.LoopPoint[C]:=D.Note;
    If T2>0 Then Begin
      If D.PatternLoop[C]=0 Then D.PatternLoop[C]:=T2 Else Dec(D.PatternLoop[C]);
      If D.PatternLoop[C]>0 Then Begin
        D.Note:=D.LoopPoint[C]-1;
      End;
      D.WantLast:=True;
    End;
  End;
End;

Procedure SetVolume(C,Param:Byte);
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then Begin
    ReInit(C);
    Chan[C].Volume:=Param;
    If Chan[C].Volume>64 Then Chan[C].Volume:=64;
    D.GlobVol[C]:=Chan[C].Volume;
  End;
End;

Procedure CutNote(C,Param:Byte);
Var T2:Byte;
Begin
  If Not Joue Then Exit;
  T2:=Param AND $f;
  If D.Tick=0 Then ReInit(C);
  If D.Tick=T2 Then Begin
    ReInit(C);
    StopNote(C);
    Chan[C].Volume:=0;
    D.GlobVol[C]:=Chan[C].Volume;
  End;
End;

Procedure DelayNote(C,Param:Byte);
Var T2:Byte;
Begin
  If Not Joue Then Exit;
  T2:=Param AND $f;
  If D.Tick=0 Then Begin
    ReInit(C);
    D.WasUsed[C]:=Chan[C].Used;
    Chan[C].Used:=False;
  End;
  If D.Tick=T2 Then Begin
    If D.WasUsed[C] Then Begin
      Chan[C].Used:=True;
      D.WasUsed[C]:=False;
      ReInit(C);
      CalcPer(C);
    End;
  End;
End;

Procedure DelayPat(C,Param:Byte);
Var T2:Byte;
Begin
  T2:=Param AND $f;
  If D.Tick=0 Then ReInit(C);
  If (D.Tick=0) AND (D.WaitPat=0) Then Begin
    D.WaitPat:=T2+1;
  End;
End;

Procedure Tempo(C,Param:Byte);
Begin
  If D.Tick=0 Then Begin
    ReInit(C);
    D.Bpm:=Param;
    D.CurSend:=D.CurSend-D.OpTicks;
    D.OpTicks:=Round(MixSpeed/(D.Bpm*2/5*E.Speed)*256);
    D.CurSend:=D.CurSend+D.OpTicks;
  End;
End;

Procedure GlobVol(C,Param:Byte);
Begin
  If Not Joue Then Exit;
  If (D.Tick=0) And Not Info.NoGVolUpdate Then Begin
    ReInit(C);
    D.GVol:=Param;
    If D.GVol>64 Then D.GVol:=64;
  End;
End;

Procedure Pan(C,Param:Byte);
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then ReInit(C);
  Case MType Of
    1,2:Begin
      Chan[C].Pan:=Param*2-128;
      If Chan[C].Pan<-128 Then Chan[C].Pan:=-128;
      If Chan[C].Pan>128 Then Chan[C].Pan:=128;
    End;
    3:Begin
      Chan[C].Pan:=(Param-128);
      If Chan[C].Pan<-128 Then Chan[C].Pan:=-128;
      If Chan[C].Pan>128 Then Chan[C].Pan:=128;
    End;
  End;
End;

Procedure Pan16(C,Param:Byte);
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then ReInit(C);
  Chan[C].Pan:=((Param AND $f)-8)*16;
End;

Procedure FinePortUp(C,Param:Byte);
Var T2:Byte;
Begin
  If Not Joue Then Exit;
  T2:=Param AND $f;
  If D.Tick=0 Then ReInit(C);
  If (D.Tick=0) Then Begin
    If Chan[C].Period>4 Then Dec(Chan[C].Period,T2*4) Else Chan[C].Period:=1;
    CalcPer(C);
    D.GlobPer[C]:=Chan[C].Period;
  End;
End;

Procedure FinePortDn(C,Param:Byte);
Var T2:Byte;
Begin
  If Not Joue Then Exit;
  T2:=Param AND $f;
  If D.Tick=0 Then ReInit(C);
  If (D.Tick=0) Then Begin
    Inc(Chan[C].Period,T2*4);
    CalcPer(C);
    D.GlobPer[C]:=Chan[C].Period;
  End;
End;

Procedure FineVolUp(C,Param:Byte);
Var T2:Byte;
Begin
  If Not Joue Then Exit;
  T2:=Param AND $f;
  If D.Tick=0 Then Begin
    ReInit(C);
    If Chan[C].Volume+T2<=64 Then Inc(Chan[C].Volume,T2) Else Chan[C].Volume:=64;
  End;
  D.GlobVol[C]:=Chan[C].Volume;
End;

Procedure FineVolDn(C,Param:Byte);
Var T2:Byte;
Begin
  If Not Joue Then Exit;
  T2:=Param AND $f;
  If D.Tick=0 Then Begin
    ReInit(C);
    If Chan[C].Volume>=T2 Then Dec(Chan[C].Volume,T2) Else Chan[C].Volume:=0;
    D.GlobVol[C]:=Chan[C].Volume;
  End;
End;

Procedure PanSlideLeft(C,Param:Byte);
Var T2:Integer;
Begin
  If Not Joue Then Exit;
  If Param<>0 Then D.LastSL[C]:=Param;
  T2:=D.LastSL[C] AND $f;
  If D.Tick=0 Then Begin
    ReInit(C);
  End Else Begin
    If Chan[C].Pan-T2>-128 Then Dec(Chan[C].Pan,T2) Else Chan[C].Pan:=-128;
  End;
End;

Procedure PanSlideRight(C,Param:Byte);
Var T2:Integer;
Begin
  If Not Joue Then Exit;
  If Param<>0 Then D.LastSR[C]:=Param;
  T2:=D.LastSR[C] AND $f;
  If D.Tick=0 Then Begin
    ReInit(C);
  End Else Begin
    If Chan[C].Pan+T2<128 Then Inc(Chan[C].Pan,T2) Else Chan[C].Pan:=128;
  End;
End;

Procedure KeyOff(C,Param:Byte);
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then ReInit(C);
  If Not Instr[Chan[C].Instru].UseVolEnv Then Begin
    CutNote(C,Param);
  End Else Begin
    Chan[C].IsVolSustain:=False;
    Chan[C].UseVolSus:=False;
    Chan[C].IsPanSustain:=False;
    Chan[C].UsePanSus:=False;
    Chan[C].VFadeOut:=Instr[Chan[C].Instru].FadeOut;
  End;
End;

Procedure GlobSlide(C,Param:Byte);
Var T1,T2:Byte;
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then ReInit(C);
  If Info.NoGVolUpdate Then Exit;
  If Param<>0 Then D.LastGS[C]:=Param;
  T1:=D.LastGS[C] SHR 4;
  T2:=D.LastGS[C] AND $f;

  If (T1>0) AND (T2=0) Then Begin
    If D.GVol+T1<=64 Then Inc(D.GVol,T1) Else D.GVol:=64;
  End;
  If (T1=0) AND (T2>0) Then Begin
    If D.GVol>=T2 Then Dec(D.GVol,T2) Else D.GVol:=0;
  End;
End;

Procedure SetVibrato(C,Param:Byte);
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then ReInit(C);
  D.VibType[C]:=Param And $f;
End;

Procedure SetTremolo(C,Param:Byte);
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then ReInit(C);
  D.TremType[C]:=Param And $f;
End;

Procedure SetGliss(C,Param:Byte);
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then ReInit(C);
  D.Gliss[C]:=Param And $f;
End;

Procedure SetEnvPos(C,Param:Byte);
Var I,J:Integer;
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then Begin
    ReInit(C);

    Chan[C].PosVolEnv:=0;
    Chan[C].CurVolEnv:=0;
    Chan[C].NextVolEnv:=1;
    I:=Chan[C].Instru;
    For J:=1 To Param-1 Do Begin
      Inc(Chan[C].PosVolEnv);
      If Chan[C].PosVolEnv=Instr[I].VolEnvX[Chan[C].NextVolEnv] Then Begin
        If (Chan[C].NextVolEnv=Instr[I].LoopFVolEnv) AND Instr[I].LoopVolEnv Then Begin
          Chan[C].CurVolEnv:=Instr[I].LoopDVolEnv;
          Chan[C].NextVolEnv:=Instr[I].LoopDVolEnv+1;
          Chan[C].PosVolEnv:=Instr[I].VolEnvX[Chan[C].CurVolEnv];
        End Else Begin
          If Chan[C].NextVolEnv=Instr[I].NPntVolEnv-1 Then Begin
            Chan[C].ViteVolEnv:=0;
          End Else Begin
            Inc(Chan[C].CurVolEnv);
            Inc(Chan[C].NextVolEnv);
          End;
        End;
      End;
    End;
  End;
  DoEnv(C);
End;

Procedure PanSlide(C,Param:Byte);
Var T1,T2:Byte;
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then ReInit(C);
  If Param<>0 Then D.LastPS[C]:=Param;
  T1:=D.LastPS[C] SHR 4;
  T2:=D.LastPS[C] AND $f;
  If D.Tick=0 Then ReInit(C);
  If D.Tick<>0 Then Begin
    If (T1>0) AND (T2=0) Then Begin
      If Chan[C].Pan+T1<=128 Then Inc(Chan[C].Pan,T1) Else Chan[C].Pan:=128;
    End;
    If (T1=0) AND (T2>0) Then Begin
      If Chan[C].Pan>=-128 Then Dec(Chan[C].Pan,T2) Else Chan[C].Pan:=-128;
    End;
  End;
End;

Procedure XUp(C,Param:Byte);
Begin
  If Not Joue Then Exit;
  If Param<>0 Then Begin
    D.LastSD[C]:=Param;
    D.LastSU[C]:=Param;
  End;
  If D.Tick=0 Then ReInit(C);
  If D.Tick<>0 Then Begin
    If Chan[C].Period>D.LastSU[C] Then Dec(Chan[C].Period,D.LastSU[C]) Else Chan[C].Used:=False;
    CalcPer(C);
    D.GlobPer[C]:=Chan[C].Period;
  End;
End;

Procedure XDown(C,Param:Byte);
Begin
  If Not Joue Then Exit;
  If Param<>0 Then Begin
    D.LastSD[C]:=Param;
    D.LastSU[C]:=Param;
  End;
  If D.Tick=0 Then ReInit(C);
  If D.Tick<>0 Then Begin
    Inc(Chan[C].Period,D.LastSD[C]);
    CalcPer(C);
    D.GlobPer[C]:=Chan[C].Period;
  End;
End;

Procedure MultiRetrig(C,Param:Byte);
Var T1,T2:Byte;
Begin
  If Not Joue Then Exit;
  If D.Tick=0 Then Begin
    ReInit(C);
  End Else Begin
    If Param<>0 Then D.LastRet[C]:=Param;
    T1:=D.LastRet[C] SHR 4;
    T2:=D.LastRet[C] AND $f;
    If T2=0 Then Exit;
    If D.Tick MOD T2=0 Then Begin
      Chan[C].Ofs:=Deca SHL Fixed;
      Case T1 Of
        $1:If Chan[C].Volume>=1 Then Dec(Chan[C].Volume) Else Chan[C].Volume:=0;
        $2:If Chan[C].Volume>=2 Then Dec(Chan[C].Volume,2) Else Chan[C].Volume:=0;
        $3:If Chan[C].Volume>=4 Then Dec(Chan[C].Volume,4) Else Chan[C].Volume:=0;
        $4:If Chan[C].Volume>=8 Then Dec(Chan[C].Volume,8) Else Chan[C].Volume:=0;
        $5:If Chan[C].Volume>=16 Then Dec(Chan[C].Volume,16) Else Chan[C].Volume:=0;
        $6:Chan[C].Volume:=Chan[C].Volume*2 Div 3;
        $7:Chan[C].Volume:=Chan[C].Volume Div 2;
        $9:Inc(Chan[C].Volume);
        $a:Inc(Chan[C].Volume,2);
        $b:Inc(Chan[C].Volume,4);
        $c:Inc(Chan[C].Volume,8);
        $d:Inc(Chan[C].Volume,16);
        $e:Chan[C].Volume:=Chan[C].Volume*3 Div 2;
        $f:Chan[C].Volume:=Chan[C].Volume*2;
      End;
      If Chan[C].Volume>64 Then Chan[C].Volume:=64;
      D.GlobVol[C]:=Chan[C].Volume;
    End;
  End;
End;
