{Cette unit se charge de l'interface entre PMP et la dll
 de visualisation et se passe de commentaires.

 Global->Graphs
 Gui->Graphs

 }

unit graphs;

interface
uses windows,global,gui;

type
  tnewplay=procedure;stdcall;
  tinitdc=procedure(hn:hwnd;tx,ty:longword);stdcall;
  tuninitdc=procedure;stdcall;
  tdodc=procedure(hn:hwnd;pl:boolean);stdcall;
  tcleandc=procedure(hn:hwnd);stdcall;
  tinitpatt=procedure(hn:hwnd;tx,ty:LongWord);stdcall;
  tuninitpatt=procedure;stdcall;
  tdopatt=procedure(hn:hwnd;pos:byte;pl:boolean);stdcall;
  tcleanpatt=procedure(hn:hwnd);stdcall;
  tgetinfo=function(param:longword):longint;stdcall;
  tinitvis=procedure(loadproc:tloadproc);stdcall;
  tendvis=procedure;stdcall;
  tsetupvis=procedure;stdcall;
  tsetuppattern=procedure;stdcall;

var
  pnewplay:tnewplay;
  pinitdc:tinitdc;
  puninitdc:tuninitdc;
  pdodc:tdodc;
  pcleandc:tcleandc;
  pinitpatt:tinitpatt;
  puninitpatt:tuninitpatt;
  pdopatt:tdopatt;
  pcleanpatt:tcleanpatt;
  pgetinfo:tgetinfo;
  pinitvis:tinitvis;
  pendvis:tendvis;
  psetupvis:tsetupvis;
  psetuppattern:tsetuppattern;


  procedure newplay;stdcall;
  procedure initdc(hn:hwnd;tx,ty:longword);stdcall;
  procedure uninitdc;stdcall;
  procedure dodc(hn:hwnd;pl:boolean);stdcall;
  procedure cleandc(hn:hwnd);stdcall;
  procedure initpatt(hn:hwnd;tx,ty:LongWord);stdcall;
  procedure uninitpatt;stdcall;
  procedure dopatt(hn:hwnd;pos:byte;pl:boolean);stdcall;
  procedure cleanpatt(hn:hwnd);stdcall;
  function getvisinfo(param:longword):longint;stdcall;
  function initgraphs(hn1,hn2:hwnd;tx1,ty1,tx2,ty2:LongWord):boolean;
  procedure endgraphs;
  procedure setupvis;stdcall;
  procedure setuppattern;stdcall;


implementation
var handle:integer;
    visloaded:boolean;

procedure newplay;stdcall;
begin
  if visloaded then pnewplay;
end;

procedure initdc(hn:hwnd;tx,ty:longword);stdcall;
begin
  if visloaded then pinitdc(hn,tx,ty);
end;

procedure uninitdc;stdcall;
begin
  if visloaded then puninitdc;
end;

procedure dodc(hn:hwnd;pl:boolean);stdcall;
begin
  if visloaded then pdodc(hn,pl);
end;

procedure cleandc(hn:hwnd);stdcall;
begin
  if visloaded then pcleandc(hn);
end;

procedure initpatt(hn:hwnd;tx,ty:LongWord);stdcall;
begin
  if visloaded then pinitpatt(hn,tx,ty);
end;

procedure uninitpatt;stdcall;
begin
  if visloaded then puninitpatt;
end;

procedure dopatt(hn:hwnd;pos:byte;pl:boolean);stdcall;
begin
  if visloaded then pdopatt(hn,pos,pl);
end;

procedure cleanpatt(hn:hwnd);stdcall;
begin
  if visloaded then pcleanpatt(hn);
end;

procedure setupvis;stdcall;
begin
  if visloaded then psetupvis;
end;

procedure setuppattern;stdcall;
begin
  if visloaded then psetuppattern;
end;

function getvisinfo(param:longword):longint;stdcall;
begin
  if visloaded then getvisinfo:=pgetinfo(param) else getvisinfo:=-1;
end;

function initgraphs(hn1,hn2:hwnd;tx1,ty1,tx2,ty2:LongWord):boolean;
var f:string;
begin
  f:=globalinfo.Config.VisFileName;
  globalinfo.status.visdirectory:=getdir(3);
  initgraphs:=false;
  visloaded:=false;
  f:=f+#0;
  handle:=loadlibrary(@f[1]);
  if handle=0 then exit;
  @pnewplay:=GetProcAddress(Handle, 'NewPlay');
  if @pnewplay=nil then exit;
  @pinitdc:=GetProcAddress(Handle, 'InitVis');
  if @pinitdc=nil then exit;
  @puninitdc:=GetProcAddress(Handle, 'UnInitVis');
  if @puninitdc=nil then exit;
  @pdodc:=GetProcAddress(Handle, 'DoVis');
  if @pdodc=nil then exit;
  @pcleandc:=GetProcAddress(Handle, 'ClearVis');
  if @pcleandc=nil then exit;
  @pinitpatt:=GetProcAddress(Handle, 'InitPattern');
  if @pinitpatt=nil then exit;
  @puninitpatt:=GetProcAddress(Handle, 'UnInitPattern');
  if @puninitpatt=nil then exit;
  @pdopatt:=GetProcAddress(Handle, 'DoPattern');
  if @pdopatt=nil then exit;
  @pcleanpatt:=GetProcAddress(Handle, 'ClearPattern');
  if @pcleanpatt=nil then exit;
  @pgetinfo:=GetProcAddress(Handle, 'GetInfo');
  if @pgetinfo=nil then exit;
  @pinitvis:=GetProcAddress(Handle, 'GlobalInit');
  if @pinitvis=nil then exit;
  @pendvis:=GetProcAddress(Handle, 'GlobalUnInit');
  if @pendvis=nil then exit;
  @psetupvis:=GetProcAddress(Handle, 'SetupVis');
  if @psetupvis=nil then begin
    @psetupvis:=GetProcAddress(Handle, 'setupvis');
    if @psetupvis=nil then exit;
  end;
  @psetuppattern:=GetProcAddress(Handle, 'SetupPattern');
  if @psetuppattern=nil then begin
    @psetuppattern:=GetProcAddress(Handle, 'setuppattern');
    if @psetuppattern=nil then exit;
  end;

  visloaded:=true;
  pinitvis(loadproc);
  initdc(hn1,tx1,ty1);
  initpatt(hn2,tx2,ty2);
  if globalinfo.status.isplaying then newplay;
  initgraphs:=true;
end;

procedure endgraphs;
begin
  if visloaded then begin
    pendvis;
    visloaded:=false;
    uninitdc;
    uninitpatt;
    freelibrary(handle);
  end;
end;

begin
  visloaded:=false;
end.

