unit unit3d;

interface
type
  trender=record
    backface:boolean;
    lum:boolean;
  end;

  tcoo=record
    x,y,z:longint;
  end;

  tangle=record
    a1,a2,a3:longint;
  end;

  tscoo=record
    x,y,z:single;
  end;

  tspoint=record
    coo:tscoo;
    color:longword;
  end;

  tpoint=record
    coo:tcoo;
    color:longword;
  end;

  tsurface=record
    npoint:longint;
    point:array of longint;
    normpoint:longint;
    render:trender;
    color:longword;
    dir:shortint;
    visible:boolean;
  end;

  t3dobj=record
    nsurface:longint;
    npoint:longint;
    surface:array of tsurface;
    point:array of tpoint;
    coo:tcoo;
    angle:tangle;
  end;

  tworld=record
    lumx,lumy,lumz:longint;
    ambiant:longint;
    zoom:integer;
    backcol:longword;
  end;

  tbmp=record
    bmp:pointer;
    tx,ty:longint;
    cx,cy:longint;
  end;

procedure drawobject(obj:t3dobj;world:tworld;where:tbmp;p3d:array of tspoint);
procedure rotateobject(npoint:longint;var p:array of tspoint;angle:tangle);

implementation
  type
    tflatcoo=record
      x,y:longint;
    end;

    tflatpoint=record
      coo:tflatcoo;
      color:longword;
    end;

    tflatsurface=record
      npoint:longint;
      point:array of tflatpoint;
      color:longword;
    end;

var sn,cs:array[-3599..3599] of single;

procedure pset(x,y:longint;c:longword;where:tbmp);
var adr:longword;
begin
  adr:=(x+y*where.tx)*4;
  if (x>=0) and (y>=0) and (x<where.tx) and (y<where.ty) then begin
    asm
      push ebx
      push edi
      mov eax, c
      mov ebx, where.bmp
      mov edi, adr
      mov [ebx+edi],eax
      pop edi
      pop ebx
    end;
  end;
end;

procedure drawsurface(surface:tflatsurface;where:tbmp);
var o,tmy:array of longint;
    i,j,trv,pnt,temp,y,y1:longint;
    dx1,dx2,x1,x2:single;
    to1,to2:longint;
    lx1,lx2,ta:longint;
    adr:longword;
begin
  with surface do begin
    setlength(o,npoint);
    setlength(tmy,npoint);
    for i:=0 to npoint-1 do begin
      o[i]:=i;
      tmy[i]:=point[i].coo.y;
    end;
    for i:=0 to npoint-2 do begin
      trv:=i;
      for j:=i+1 to npoint-1 do if tmy[j]<tmy[trv] then trv:=j;
      temp:=tmy[i];tmy[i]:=tmy[trv];tmy[trv]:=temp;
      temp:=o[i];o[i]:=o[trv];o[trv]:=temp;
    end;
    y:=point[o[0]].coo.y;
    x1:=point[o[0]].coo.x;
    x2:=x1;
    to1:=o[0]+1;if to1=npoint then to1:=0;
    to2:=o[0]-1;if to2=-1 then to2:=npoint-1;
    for pnt:=0 to npoint-2 do begin
      dx1:=0;if y<>point[to1].coo.y then dx1:=(point[to1].coo.x-x1)/(point[to1].coo.y-y) else x1:=point[to1].coo.x;
      dx2:=0;if y<>point[to2].coo.y then dx2:=(point[to2].coo.x-x2)/(point[to2].coo.y-y) else x2:=point[to2].coo.x;
      for y1:=y to point[o[pnt+1]].coo.y-1 do begin
        if (y1>=0) and (y1<where.ty) then begin
          lx1:=round(x1);lx2:=round(x2);
          if lx1>lx2 then begin temp:=lx1;lx1:=lx2;lx2:=temp;end;
          if lx1<0 then lx1:=0;
          if lx2>where.tx-1 then lx2:=where.tx-1;
          ta:=lx2-lx1+1;
          if ta>0 then begin
            adr:=(lx1+y1*where.tx)*4;
            asm
              push ecx
              push edi
              mov ecx, ta
              mov eax, surface.color
              mov edi, adr
              add edi, where.bmp
              rep stosd
              pop edi
              pop ecx
            end;
          end;
        end;
        x1:=x1+dx1;
        x2:=x2+dx2;
      end;
      y:=point[o[pnt+1]].coo.y;
      if y=point[to1].coo.y then begin
        inc(to1);if to1=npoint then to1:=0;
      end else begin
        dec(to2);if to2=-1 then to2:=npoint-1;
      end;
    end;
  end;

end;

procedure rotateobject(npoint:longint;var p:array of tspoint;angle:tangle);
var i:longint;
var tx1,ty1,tz1,tx2,ty2,tz2:single;
begin
  for i:=0 to npoint-1 do begin
    {selon x}
    if angle.a1<>0 then begin
      tx2:=p[i].coo.x;
      ty2:=p[i].coo.y*cs[angle.a1]-p[i].coo.z*sn[angle.a1];
      tz2:=p[i].coo.z*cs[angle.a1]+p[i].coo.y*sn[angle.a1];
    end else begin
      tx2:=p[i].coo.x;
      ty2:=p[i].coo.y;
      tz2:=p[i].coo.z;
    end;
    {selon y}
    if angle.a2<>0 then begin
      tx1:=tx2*cs[angle.a2]+tz2*sn[angle.a2];
      ty1:=ty2;
      tz1:=tz2*cs[angle.a2]-tx2*sn[angle.a2];
    end else begin
      tx1:=tx2;
      ty1:=ty2;
      tz1:=tz2;
    end;
    {selon z}
    if angle.a3<>0 then begin
      p[i].coo.x:=tx1*cs[angle.a3]-ty1*sn[angle.a3];
      p[i].coo.y:=ty1*cs[angle.a3]+tx1*sn[angle.a3];
      p[i].coo.z:=tz1;
    end else begin
      p[i].coo.x:=tx1;
      p[i].coo.y:=ty1;
      p[i].coo.z:=tz1;
    end;
  end;
end;

procedure drawobject(obj:t3dobj;world:tworld;where:tbmp;p3d:array of tspoint);
var i,j:longword;
    p:array of tflatpoint;
    flat:tflatsurface;
    dx1,dy1,dx2,dy2:longint;
    res:longint;
    red,green,blue:integer;
    dec:longint;
begin
  with obj do begin
    setlength(p,npoint);
    for i:=0 to npoint-1 do begin
      {projection du point}
      with p[i].coo do begin
        if p3d[i].coo.z+obj.coo.z>0 then begin
          x:=where.cx+round((p3d[i].coo.x+obj.coo.x)/(p3d[i].coo.z+obj.coo.z)*world.zoom);
          y:=where.cy+round((p3d[i].coo.y+obj.coo.y)/(p3d[i].coo.z+obj.coo.z)*world.zoom);
        end else begin
          x:=where.cx;
          y:=where.cy;
        end;
      end;
    end;
  end;
  {seconde tape, afficher les faces}
  with obj do begin
    for i:=0 to nsurface-1 do begin
      flat.npoint:=surface[i].npoint;
      setlength(flat.point,flat.npoint);
      for j:=0 to flat.npoint-1 do flat.point[j]:=p[surface[i].point[j]];
      flat.color:=surface[i].color;
      if surface[i].render.lum then begin
         red:=(flat.color shr 16) and 255;
         green:=(flat.color shr 8) and 255;
         blue:=flat.color and 255;
         dec:=-round(p3d[surface[i].normpoint].coo.x*world.lumx+p3d[surface[i].normpoint].coo.y*world.lumy+p3d[surface[i].normpoint].coo.z*world.lumz);
         inc(dec,world.ambiant);
         if dec<0 then dec:=0;
         if dec>4096 then dec:=4096;
         red:=(red*dec div (64*64));
         green:=green*dec div (64*64);
         blue:=blue*dec div (64*64);
         if red<0 then red:=0;if red>255 then red:=255;
         if green<0 then green:=0;if green>255 then green:=255;
         if blue<0 then blue:=0;if blue>255 then blue:=255;

         flat.color:=(red shl 16)+(green shl 8)+blue;
      end;
      if surface[i].visible then begin
        if not surface[i].render.backface then begin
          drawsurface(flat,where);
        end else begin
          dx1:=flat.point[0].coo.x-flat.point[1].coo.x;
          dy1:=flat.point[0].coo.y-flat.point[1].coo.y;
          dx2:=flat.point[2].coo.x-flat.point[1].coo.x;
          dy2:=flat.point[2].coo.y-flat.point[1].coo.y;
          res:=(dx1*dy2-dx2*dy1)*surface[i].dir;
          if res>0 then drawsurface(flat,where);
        end;
      end;
    end;
  end;
end;

procedure inittrigo;
var i:integer;
begin
  for i:=-3599 to 3599 do begin
    cs[i]:=cos(i/10*pi/180);
    sn[i]:=sin(i/10*pi/180);
  end;
end;

begin
  inittrigo;
end.
