library vis;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes,
  windows,
  newutils,
  billyunit,
  unit3d,
  skin;

Var OldImage,Image,H:HWnd;
Var PBitmap:Pointer;
Var BackImage:Pointer;
Var PattOldImage,PattImage,PattH:HWnd;
Var PattPBitmap:Pointer;
Var PattBackImage:Pointer;
Var Txd,Tyd,Txp,Typ,NChan,NLin,PLin:LongWord;
    billy:tbilly;
    script:tscript;
    world:tworld;
    bmp:tbmp;
    mode:integer;
    nscript:integer;

    OldL,OldR:Word;

Var BaseImage:LongInt;
    BaseByte:LongInt;
    LastImage:LongInt;
    LastNotePs:Single;
    LastPattern:Integer;
    Speed:Integer;
    LastNNote:Integer;
    LastChange:LongInt;
    FreqChange:Boolean;

type ttick=array[1..256] of integer;

const tai=9;
      ntai=1 shl tai;
var lastyl,lastyr:array[0..255] of longword;
var freqe:array[0..255] of word;
Var InfoStr:String;
    tick:ttick;
    dir:string;

Const Version=1 SHL 16+7;

{$i fonts.pas}

procedure fft(dir:shortint;m:byte;var x,y:array of double);
  var n,i,i1,j,k,i2,l,l1,l2:longword;
      c1,c2,tx,ty,t1,t2,u1,u2,z:double;

begin
  n:=1 shl m;
  i2:=n shr 1;
  j:=0;
  for i:=0 to n-2 do begin
    if i<j then begin
      tx:=x[i];
      ty:=y[i];
      x[i]:=x[j];
      y[i]:=y[j];
      x[j]:=tx;
      y[j]:=ty;
    end;
    k:=i2;
    while k<=j do begin
      dec(j,k);
      k:=k shr 1;
    end;
    inc(j,k);
  end;


  c1:=-1;
  c2:=0;
  l2:=1;
  for l:=0 to m-1 do begin
    l1:=l2;
    l2:=l2 shl 1;
    u1:=1;
    u2:=0;
    for j:=0 to l1-1 do begin
      i:=j;
      while i<n do begin
        i1:=i+l1;
        t1:=u1*x[i1]-u2*y[i1];
        t2:=u1*y[i1]+u2*x[i1];
        x[i1]:=x[i]-t1;
        y[i1]:=y[i]-t2;
        x[i]:=x[i]+t1;
        y[i]:=y[i]+t2;
        inc(i,l2);
      end;
      z:=u1*c1-u2*c2;
      u2:=u1*c2+u2*c1;
      u1:=z;
    end;
    c2:=sqrt((1-c1)/2);
    if dir=1 then c2:=-c2;
    c1:=sqrt((1+c1)/2);
{    if dir=1 then begin
      for i:=0 to n-1 do begin
        x[i]:=x[i]/n;
        y[i]:=y[i]/n;
      end;
    end;}
  end;
end;

procedure ClearPattern(hn:hwnd);stdcall
begin
  move(pattbackimage^,pattpbitmap^,txp*typ);
  bitblt(hn,0,0,txp,typ,pattH,0,0,SRCCOPY);
end;

procedure ClearVis(hn:hwnd);stdcall
begin
  if (mode=3) then
    move(backimage^,pbitmap^,txd*tyd*4)
  else
    move(backimage^,pbitmap^,txd*tyd);
  bitblt(hn,0,0,txd,tyd,H,0,0,SRCCOPY);
end;

Function CreateDIBSection(hdc:hwnd;bit:pointer;usage:word;pnt:pointer;truc:hwnd;machin:longword):hwnd;stdcall
external 'gdi32.dll' name 'CreateDIBSection';

procedure InitPattern(hn:hwnd;tx,ty:LongWord);stdcall
type tbi=record
  bmiHeader:bitmapinfoheader;
  bmiColors:array[0..255] of rgbquad;
end;

Var bminfo:tbi;
var w:longword;
    i,j:word;
begin
  txp:=tx;
  typ:=ty;
  nchan:=(tx-12) div (16*3);
  plin:=(ty-2) div 7;
  plin:=(plin-1) div 2;
{  nlin:=plin*2+1;
  plin:=5;
  nlin:=11;}
  nlin:=plin*2+1;
  bminfo.bmiHeader.bisize:=sizeof(tagBITMAPINFOHEADER);
  bminfo.bmiHeader.biwidth:=txp;
  bminfo.bmiHeader.biheight:=-typ;
  bminfo.bmiHeader.biplanes:=1;
  bminfo.bmiHeader.biBitCount:=8;
  bminfo.bmiHeader.bicompression:=bi_rgb;
  bminfo.bmiHeader.bisizeimage:=0;
  bminfo.bmiHeader.biXPelsPerMeter:=0;
  bminfo.bmiHeader.biYPelsPerMeter:=0;
  bminfo.bmiHeader.biclrused:=0;
  bminfo.bmiHeader.biClrImportant:=0;

  for i:=0 to 15 do begin
    bminfo.bmicolors[i].rgbred:=  ((i shr 3)*21+((i and 4) shr 2)*42)*3;
    bminfo.bmicolors[i].rgbgreen:=((i shr 3)*21+((i and 2) shr 1)*42)*0;
    bminfo.bmicolors[i].rgbblue:= ((i shr 3)*21+((i and 1) shr 0)*42)*3;
  end;
  bminfo.bmicolors[254].rgbred:=240;
  bminfo.bmicolors[254].rgbgreen:=220;
  bminfo.bmicolors[254].rgbblue:=0;
  bminfo.bmicolors[255].rgbred:=$ff;
  bminfo.bmicolors[255].rgbgreen:=$ff;
  bminfo.bmicolors[255].rgbblue:=$ff;

  patth:=CreateCompatibleDC(hn);
  pattimage:=createdibsection(0,@bminfo,DIB_RGB_COLORS,@pattpbitmap,0,0);
  pattoldimage:=selectobject(patth,pattimage);

  getmem(pattbackimage,txp*typ);
  fillchar(pattbackimage^,txp*typ,0);
  for w:=(1+plin*7)*txp to (8+plin*7)*txp-1 do
    byte(pointer(longword(pattbackimage)+w)^):=7;
(*    memwriteb(pattbackimage,w,7);*)
  for i:=0 to nchan-1 do begin
    j:=i*16*3+11;
    for w:=0 to nlin*7+2 do begin
      byte(pointer(longword(pattbackimage)+j+w*txp+0)^):=7;
      byte(pointer(longword(pattbackimage)+j+w*txp+1)^):=15;
      byte(pointer(longword(pattbackimage)+j+w*txp+2)^):=7;
      byte(pointer(longword(pattbackimage)+j+w*txp+3)^):=8;
(*      memwriteb(pattbackimage,j+w*txp+0,7);
      memwriteb(pattbackimage,j+w*txp+1,15);
      memwriteb(pattbackimage,j+w*txp+2,7);
      memwriteb(pattbackimage,j+w*txp+3,8);*)
    end;
  end;
  clearpattern(hn);
end;

procedure UnInitPattern;stdcall
begin
  freemem(pattbackimage);
  selectobject(patth,pattoldimage);
  deleteobject(pattimage);
  deletedc(patth);
end;

function hex(b,l:byte;z:boolean):Shortstring;
Const HexTab='0123456789ABCDEF';
begin
  if l=2 then begin
    hex:=hextab[1+b shr 4]+hextab[1+b and $f];
    if z and (b=0) then hex:='--';
  end else begin
    hex:=hextab[1+b and $f];
    if z and (b=0) then hex:='-';
  end;
end;

procedure text(pnt:pointer;offs:longword;stri:pointer;size:word;ret:longword;col:byte;fnt:pointer);
begin
    asm
      pushad
      mov cx, size
      mov dl, col
@lpf:
      push cx
      mov edi, pnt
      add edi, offs
      mov ebx, stri
      inc stri

      xor eax, eax
      mov al, [ebx]
      shl eax, 4
      mov esi, fnt
      add esi, eax
      mov cx, 5
@lp:
        cmp byte ptr [esi], 0
        jz @np1
        mov [edi], dl
@np1:
        cmp byte ptr [esi+1], 0
        jz @np2
        mov [edi+1], dl
@np2:
        cmp byte ptr [esi+2], 0
        jz @np3
        mov [edi+2], dl
@np3:
        add edi, ret
        add esi, 3
        dec cx
        jnz @lp
      add offs, 3
    pop cx
    dec cx
    jnz @lpf
    popad
  end;
end;


procedure DoPattern(hn:hwnd;pos:byte;pl:boolean);stdcall
var pt:pointer;

Var I,T,Chan:Byte;
    Note:Integer;
    CNote,CPatt,CPos:Byte;
Var X:word;
Var Txt:ShortString;
Var Offs:LongWord;
Var MaxChan:Word;
Var U,V:LongWord;
Label Nop;
const col=254;
begin
  pt:=pattpbitmap;
  move(pattbackimage^,pt^,txp*typ);

  T:=PMod.GetMod(31);
  If (PMod.GetMod(24)<>0) Or Not Pl Then Goto Nop;

  CPatt:=PMod.GetMod(6);
  CNote:=PMod.GetMod(7);
  CPos:=PMod.GetMod(8);
  MaxChan:=PMod.GetMod(9)-1;
  If MaxChan>nchan-1 Then MaxChan:=nchan-1;

  Offs:=txp*2+3;
  For Note:=CNote-plin To CNote+plin Do Begin
    X:=0;
    If (Note<=PMod.GetPattern(CPos,0,0,6)) AND (Note>0) Then Begin
      Txt:=Hex(Note,2,False)+'   ';
      Text(pt,Offs,@txt[1],length(txt),txp,col,@font);
      Inc(X,length(txt)*3);
      Inc(Offs,length(txt)*3);


      For I:=0 To MaxChan Do Begin
        Chan:=I+Pos;
        Txt:=PMod.GetPatternS(CPatt,Note,Chan,1)+' ';

        Txt:=Txt+Hex(PMod.GetPattern(CPatt,Note,Chan,1),2,True)+' ';
        Txt:=Txt+Hex(PMod.GetPattern(CPatt,Note,Chan,5),2,True)+' ';
        U:=PMod.GetPattern(CPatt,Note,Chan,3);
        V:=PMod.GetPattern(CPatt,Note,Chan,4);
        If U+V=0 Then Txt:=Txt+'---' Else Begin
          If T<>2 Then Txt:=Txt+Hex(U,1,False) Else Txt:=Txt+Chr(U+64);
          Txt:=Txt+Hex(V,2,False);
        End;
        Txt:=Txt+'   ';
        inc(x,length(txt)*3);
        Text(pt,offs,@txt[1],length(txt),txp,col,@font);
        inc(offs,length(txt)*3);

      End;
    End;
    inc(offs, 7*txp-x);
  End;
nop:
  bitblt(hn,0,0,txp,typ,pattH,0,0,SRCCOPY);
end;

const ncampos=10;
const campos:array[0..ncampos-1,0..2] of integer=(
(-1100,1350,-150),
(-1100,-1350,150),
(-1500,500,-500),
(-1500,-500,500),
(-900,-400,0),
(0,-400,-900),
(0,400,900),
(-1800,400,-900),
(-1000,1800-1350,-50),
(-900,900,0)
);

procedure newscript;
var i:integer;
begin
  nscript:=0;
  i:=random(ncampos);
  setviewangle(billy,campos[i,0],campos[i,1],campos[i,2]);
end;


procedure InitVis(hn:hwnd;tx,ty:longword);stdcall
type tbi=record
  bmiHeader:bitmapinfoheader;
  bmiColors:array[0..255] of rgbquad;
end;

Var bminfo:tbi;
Var I:Byte;
    cols:tcolor;
    render:trender;
{Var W:LongWord;}
begin
  txd:=tx;
  tyd:=ty;
  mode:=1;
  if (txd=320) and (tyd=200) then mode:=3;
  if (txd=320) and (tyd<>200) then mode:=2;
  bminfo.bmiHeader.bisize:=sizeof(tagBITMAPINFOHEADER);
  bminfo.bmiHeader.biwidth:=txd;
  bminfo.bmiHeader.biheight:=-tyd;
  bminfo.bmiHeader.biplanes:=1;
  if (mode=1) or (mode=2) then
    bminfo.bmiHeader.biBitCount:=8
  else
    bminfo.bmiHeader.biBitCount:=32;
  bminfo.bmiHeader.bicompression:=bi_rgb;
  bminfo.bmiHeader.bisizeimage:=0;
  bminfo.bmiHeader.biXPelsPerMeter:=0;
  bminfo.bmiHeader.biYPelsPerMeter:=0;
  bminfo.bmiHeader.biclrused:=0;
  bminfo.bmiHeader.biClrImportant:=0;

  if (mode=1) or (mode=2) then begin
    bminfo.bmicolors[0].rgbred:=$0;
    bminfo.bmicolors[0].rgbgreen:=$0;
    bminfo.bmicolors[0].rgbblue:=$0;
    bminfo.bmicolors[1].rgbred:=$80;
    bminfo.bmicolors[1].rgbgreen:=$80;
    bminfo.bmicolors[1].rgbblue:=0;
    bminfo.bmicolors[2].rgbred:=$40;
    bminfo.bmicolors[2].rgbgreen:=$40;
    bminfo.bmicolors[2].rgbblue:=0;
    bminfo.bmicolors[3].rgbred:=$ff;
    bminfo.bmicolors[3].rgbgreen:=0;
    bminfo.bmicolors[3].rgbblue:=0;
    bminfo.bmicolors[4].rgbred:=$80;
    bminfo.bmicolors[4].rgbgreen:=0;
    bminfo.bmicolors[4].rgbblue:=0;
    bminfo.bmicolors[5].rgbred:=0;
    bminfo.bmicolors[5].rgbgreen:=$ff;
    bminfo.bmicolors[5].rgbblue:=0;
    bminfo.bmicolors[6].rgbred:=0;
    bminfo.bmicolors[6].rgbgreen:=$80;
    bminfo.bmicolors[6].rgbblue:=0;
    bminfo.bmicolors[255].rgbred:=$ff;
    bminfo.bmicolors[255].rgbgreen:=$ff;
    bminfo.bmicolors[255].rgbblue:=$ff;
    for i:=128 to 159 do begin
      bminfo.bmicolors[i].rgbred:=255;
      bminfo.bmicolors[i].rgbgreen:=(159-i)*8;
      bminfo.bmicolors[i].rgbblue:=0;
    end;
    for i:=160 to 191 do begin
      bminfo.bmicolors[i].rgbred:=(159-i)*8;
      bminfo.bmicolors[i].rgbgreen:=255;
      bminfo.bmicolors[i].rgbblue:=0;
    end;
  end;

  h:=CreateCompatibleDC(hn);
  image:=createdibsection(0,@bminfo,DIB_RGB_COLORS,@pbitmap,0,0);
  oldimage:=selectobject(h,image);

  if (mode=1) or (mode=2) then begin
    getmem(backimage,txd*tyd);
    fillchar(backimage^,txd*tyd,0);
  end else begin
    getmem(backimage,txd*tyd*4);
    fillchar(backimage^,txd*tyd*4,0);
  end;
{  w:=0;}
{  for i:=0 to tyd-1 do begin}
{    memwriteb(backimage,w+25,1);}
{    memwriteb(backimage,w+24,2);
    memwriteb(backimage,w+26,2);}
{    memwriteb(backimage,w+102,1);}
{    memwriteb(backimage,w+101,2);
    memwriteb(backimage,w+103,2);}
{    inc(w,txd)}
{  end;}

  for i:=0 to 13 do script.order[i].init:=false;

  bmp.bmp:=pbitmap;
  bmp.tx:=tx;
  bmp.ty:=ty;
  bmp.cx:=tx div 2;
  bmp.cy:=ty div 2;
  world.zoom:=500;

  world.lumx:=0;
  world.lumy:=0;
  world.lumz:=-1;
  world.ambiant:=1024;

  cols.peau:=$ffa0ff;
  cols.short:=$0000ff;
  cols.blouse:=$ffffff;
  cols.shoes:=$aaaaaa;
(*  cols.cheveux:=$aa4000;*)
  cols.cheveux:=$ffff00;

  render.lum:=true;
  render.backface:=true;
  initbilly(billy,world,cols,render);
  load(dir+'marche.bsc',script);
  clearvis(hn);

  lastnoteps:=0;
  lastimage:=0;
  lastpattern:=-1;
  lastnnote:=-1;
  baseimage:=0;
  basebyte:=pmod.getmod(15);
  lastchange:=-1;
  freqchange:=false;
  newscript;

end;

procedure UnInitVis;stdcall
begin
  freemem(backimage);
  selectobject(h,oldimage);
  deleteobject(image);
  deletedc(h);
end;

procedure initfour(frq:word);stdcall
var i:word;
    j:double;
begin
  for i:=0 to 255 do begin
    lastyl[i]:=0;
    lastyr[i]:=0;
  end;
  for i:=0 to 19 do begin
    j:=i*150;
    freqe[i]:=round(j*ntai/frq)+1;
  end;
end;


procedure counttick(var tick:ttick);
var i,speed:integer;
var pos,size,chan,dnote,c:integer;
    tpe,cmd,param,patt:integer;
begin
  dnote:=pmod.getmod(7);
  speed:=pmod.getmod(32);
  tick[dnote]:=speed;
  pos:=pmod.getmod(8);
  patt:=pmod.getmod(6);
  size:=pmod.getpattern(pos,0,0,6);
  chan:=pmod.getmod(9);
  tpe:=pmod.getmod(31);
  for i:=dnote+1 to size do begin
    for c:=0 to chan-1 do begin
      cmd:=pmod.getpattern(patt,i,c,3);
      param:=pmod.getpattern(patt,i,c,4);
      case tpe of
        1:begin
          if cmd=$f then if (param<32) and (param<>0) then speed:=param;
        end;
        2:begin
          if cmd=$1 then if param<>0 then speed:=param;
        end;
        3:begin
          if cmd=$f then if param<>0 then speed:=param;
        end;
      end;
      tick[i]:=speed;
    end;
  end;
end;

function getpos:longint;
var pc:single;
    note,patt,size,chan:integer;
    i,j:integer;
    nnote:integer;
    tnnote:array[0..63] of integer;
    pos:longint;
    ntick:integer;
    const min=2;
          max=4;
begin
  getpos:=0;
  if basebyte>pmod.getmod(15) then basebyte:=pmod.getmod(15);
  note:=pmod.getmod(7);
  patt:=pmod.getmod(6);
  pos:=pmod.getmod(8);
  size:=pmod.getpattern(pos,0,0,6);
  chan:=pmod.getmod(9);
  ntick:=pmod.getmod(38);
  if size=0 then exit;
  if patt<>lastpattern then begin
    counttick(tick);
    nnote:=0;
    for i:=0 to chan-1 do begin
      tnnote[i]:=0;
      for j:=1 to size do begin
        if pmod.getpattern(patt,j,i,2)<>0 then inc(tnnote[i]);
      end;
      inc(nnote,tnnote[i]);
    end;
    for i:=0 to chan-1 do if tnnote[i]<nnote/10 then dec(chan);

    if chan=0 then chan:=1;
    nnote:=1000*nnote div size div chan;
    if lastnnote<>0 then if (abs(nnote-lastnnote)/lastnnote<0.2) and (lastnnote<>-1) then nnote:=lastnnote;
    lastnnote:=nnote;

    if nnote<100 then speed:=2;
    if (nnote>=100) and (nnote<200) then speed:=4;
    if (nnote>=200) and (nnote<400) then speed:=8;
    if (nnote>=400) and (nnote<800) then speed:=16;
    if (nnote>=800) then speed:=32;
    lastpattern:=patt;
    inc(nscript);
    if (random(4)=2) and (nscript>1) or (nscript>4) then newscript;
  end;
  (*speed contient le nombre de notes  parcourir*)
  if tick[note]=0 then exit;
  pc:=(note+ntick/tick[note])/size*speed;
  getpos:=round(pc*script.tempo) mod script.length;
end;

procedure DoVis(hn:hwnd;pl:boolean);stdcall

var pntr:pointer;
    pt:pointer;
var bufferinl:array of double;
var bufferinr:array of double;

var i:integer;
    yl,yr:longword;
    adr:longword;
var v:byte;
var voutl,voutr,dcl,dcr:double;

var vl,vr:longint;
    l,r:word;

var bid1,bid2:array of double;

label nop;
begin

  case mode of
  1:begin
    move(backimage^,pbitmap^,txd*tyd);
    If (PMod.GetMod(24)<>0) Or Not Pl Then Goto Nop;
    pt:=pbitmap;
    v:=1;

    if PMod.getmod(21)=1 then begin
      (*16bit*)
      if PMod.getmod(12)=1 then begin
      (*stereo*)
        pntr:=ptr(PMod.getmod(20)+((PMod.getmod(17) shr (tai+2)) shl (tai+2)));
        if pntr<>nil then begin
          asm
            pushad
            mov esi, pntr
            mov edi, pt
            mov cx, 80
            xor ebx, ebx
@lp:
            mov bx, [esi]
            sar bx, 10
            add bx, 25
            cmp bx, 1
            jl @np1
            cmp bx, 49
            jg @np1
            mov byte ptr [edi+ebx-1], 4
            mov byte ptr [edi+ebx], 3
            mov byte ptr [edi+ebx+1], 4
@np1:
            mov bx, [esi+2]
            sar bx, 10
            add bx, 102
            cmp bx, 78
            jl @np2
            cmp bx, 126
            jg @np2
            mov byte ptr [edi+ebx-1], 6
            mov byte ptr [edi+ebx], 5
            mov byte ptr [edi+ebx+1], 6
@np2:
            add esi, 8
            add edi, txd
            dec cx
            jnz @lp
            popad
          end;
          setlength(bid1,ntai);
          setlength(bid2,ntai);
          setlength(bufferinl,ntai);
          setlength(bufferinr,ntai);
          for i:=0 to ntai-1 do begin
            bufferinl[i]:=word(pointer(longint(pntr)+i*4+2)^)-32768;
            bufferinr[i]:=word(pointer(longint(pntr)+i*4)^)-32768;
            bid1[i]:=0;
            bid2[i]:=0;
          end;

          fft(1,tai,bufferinl,bid1);
          fft(1,tai,bufferinr,bid2);
          adr:=0;


          dcl:=bufferinl[0]/4000000;
          dcr:=bufferinr[0]/4000000;
          for i:=0 to 19 do begin
            voutl:=bufferinl[freqe[19-i]];
            voutr:=bufferinr[freqe[19-i]];

            yl:=round(abs(voutl*dcl/200000));
            yr:=round(abs(voutr*dcr/200000));
            if yl>=lastyl[i] then lastyl[i]:=yl else if lastyl[i]>v then dec(lastyl[i],v) else lastyl[i]:=0;
            if yr>=lastyr[i] then lastyr[i]:=yr else if lastyr[i]>v then dec(lastyr[i],v) else lastyr[i]:=0;
            if lastyl[i]>31 then lastyl[i]:=31;
            if lastyr[i]>31 then lastyr[i]:=31;
            yl:=lastyl[i];
            yr:=lastyr[i];
            asm
              pushad
              mov edi, pt
              add edi, adr
              mov cx, 3

@lp:
              push cx
              mov ecx, yl
              inc cx
              mov ebx, 0
@lp1:
              mov al, bl
              add al, 128+32
              mov [edi+ebx+64], al
              inc ebx
              dec ecx
              jnz @lp1

              mov ecx, yr
              inc cx
              mov ebx, 0
@lp2:
              mov al, bl
              neg al
              add al, 128
              mov [edi+ebx+63], al
              dec ebx
              dec ecx
              jnz @lp2

              add edi, txd

              pop cx
              dec cx
              jnz @lp
              sub edi, pt
              mov adr, edi
              popad
            end;
            inc(adr,txd);
          end;
        end;
      end else begin
        (*mono*)
        pntr:=ptr(PMod.getmod(20)+((PMod.getmod(17) shr 9) shl 9));
        if pntr<>nil then begin
        end;
      end;
    end else begin
      (*8bit*)
      if PMod.getmod(12)=1 then begin
      (*stereo*)
        pntr:=ptr(PMod.getmod(20)+((PMod.getmod(17) shr 9) shl 9));
        if pntr<>nil then begin


        end;
      end else begin
        (*mono*)
        pntr:=ptr(PMod.getmod(20)+((PMod.getmod(17) shr 8) shl 8));
        if pntr<>nil then begin

        end;
      end;
    end;
  end;
  2:begin
    move(backimage^,pbitmap^,txd*tyd);
    If (PMod.GetMod(24)<>0) Or Not Pl Then Goto Nop;
    pt:=pbitmap;
    if (PMod.getmod(21)=1) and (PMod.getmod(12)=1) then begin
      pntr:=ptr(PMod.getmod(20)+((PMod.getmod(17) shr (tai+2)) shl (tai+2)));
      if pntr<>nil then begin
        vl:=0;vr:=0;
        for i:=0 to 318 do begin
          asm
            pushad
            mov edi, pntr
            mov ebx, i
            shl ebx, 2

            movsx eax, word ptr [ebx+edi]
            add vl, eax
            movsx eax, word ptr [ebx+edi+4]
            sub vl, eax

            movsx eax, word ptr [ebx+edi+2]
            add vr, eax
            movsx eax, word ptr [ebx+edi+6]
            sub vr, eax

            popad
          end;
        end;
        l:=abs(vl div 100);
        if l>320 then l:=320;
        r:=abs(vr div 100);
        if r>320 then r:=320;

        if l>oldl then oldl:=l else if oldl>3 then dec(oldl,3) else oldl:=0;
        if r>oldr then oldr:=r else if oldr>3 then dec(oldr,3) else oldr:=0;

        asm
          pushad
          mov edi, pt
          mov cx, oldl
          cmp cx, 0
          je @fin
          mov ax, $8000+4*256
@lp:
          xor ebx, ebx
          mov dx, 50
@vr:
          mov [edi+ebx], ah
          add ebx, 320
          dec dx
          jnz @vr

          add ax, 28*256/320
          inc edi
          dec cx
          jnz @lp
@fin:
          popad
        end;
        asm
          pushad
          mov edi, pt
          add edi, 50*320
          mov cx, oldr
          cmp cx, 0
          je @fin
          mov ax, $8000+(32+4)*256
@lp:
          xor ebx, ebx
          mov dx, 50
@vr:
          mov [edi+ebx], ah
          add ebx, 320
          dec dx
          jnz @vr

          add ax, 28*256/320
          inc edi
          dec cx
          jnz @lp
@fin:
          popad
        end;

        asm
          pushad
          mov edi, pt
          mov cx, 320
          mov esi, pntr
          xor ebx, ebx
@lp:
          mov ax, [esi]
          sar ax, 10
          add ax, 24
          mov bx, ax
          sal bx, 6
          sal ax, 8
          add bx, ax
          cmp bx, 98*320
          ja @no1
          cmp bx, 1*320
          jb @no1
          mov byte ptr [ebx+edi-320],4
          mov byte ptr [ebx+edi],3
          mov byte ptr [ebx+edi+320],4
@no1:
          mov ax, [esi+2]
          sar ax, 10
          add ax, 24+50
          mov bx, ax
          sal bx, 6
          sal ax, 8
          add bx, ax
          cmp bx, 1*320
          jb @no2
          cmp bx, 98*320
          ja @no2
          mov byte ptr [ebx+edi-320],6
          mov byte ptr [ebx+edi],5
          mov byte ptr [ebx+edi+320],6
@no2:
          add esi, 4
          inc edi
          dec cx
          jnz @lp
          popad
        end;
      end;
    end;
  end;
  3:begin
    move(backimage^,pbitmap^,txd*tyd*4);
    If (PMod.GetMod(24)<>0) Or Not Pl Then Goto Nop;
    setbilly(billy,script,getpos);
    showbilly(billy,world,bmp);
  end;
  end;
  nop:
  bitblt(hn,0,0,txd,tyd,H,0,0,SRCCOPY);
end;

Function GetInfo(Param:LongWord):LongInt;stdcall
Begin
  GetInfo:=-1;
  Case Param Of
    (*get nchan*)
    1:Begin
      GetInfo:=NChan;
    End;
    (*get requested pmp version*)
    2:Begin
      GetInfo:=Version;
    End;
  End;
End;

procedure NewPlay;stdcall
begin
  initfour(pmod.getmod(33));
  oldr:=0;
  oldl:=0;
  newscript;
end;

function GetInfoStr:pstring;
begin
  getinfostr:=@infostr;
end;

procedure GlobalInit(LoadProc:TLoadProc);stdcall;
begin
  loadallstuff(loadproc);
  dir:=pmod.getstring(1);
end;

procedure GlobalUnInit;stdcall;
begin
end;

procedure SetupVis;stdcall;
begin

end;
procedure SetupPattern;stdcall
begin
end;

exports
  NewPlay index 1,
  InitVis index 2,
  UnInitVis index 3,
  DoVis index 4,
  InitPattern index 5,
  UnInitPattern index 6,
  DoPattern index 7,
  ClearPattern index 8,
  ClearVis index 9,
  GetInfo index 10,
  GetInfoStr index 11,
  GlobalInit index 12,
  GlobalUnInit index 13,
  SetupVis Index 14,
  SetupPattern Index 15;

begin
  txd:=128;
  tyd:=80;
  infostr:='Default pmp visualisation library';
  randomize;
end.
