unit cubeunit;

interface
type                           
  tpoint=record
    x,y,z:longint;
  end;

  tspoint=record
    x,y,z:double;
  end;

  tsurface=record
    pnt:array[0..4] of byte;
    point:array[0..3] of tpoint;
    viewed:boolean;
    int:longint;
  end;

  tbarre=record
    face:array[0..9] of tsurface;
    sideface1,sideface2:integer;
    nfaces:integer;
    center:integer;
    viewed:boolean;
    dist:double;
  end;

  tcube=record
    pnt:array[0..81] of tpoint;
    pntrot:array[0..81] of tspoint;
    pntproj:array[0..81] of tpoint;
    barre:array[0..11] of tbarre;
    face:array[0..5] of tsurface;
    order:array[0..11] of integer;
  end;

  tbmp=record
    bmp:pointer;
    tx,ty:longint;
    sx,sy:longint;
    pitch:longint;
  end;

  tworld=record
    a1,a2,a3:longint;
    cx,cy,cz:longint;
    zoom:double;
  end;

procedure initcube(var cube:tcube;cubea,cubeb:integer);
procedure drawback(cube:tcube;bitmap:tbmp;col,int:longword);
procedure drawfront(cube:tcube;bitmap:tbmp;col,int:longword);
procedure performcube(var cube:tcube;world:tworld;bitmap:tbmp);
procedure drawtrans(cube:tcube;bitmap:tbmp;col,int:longword);


implementation
const andval=16579836;

var mixtable:array[0..255,0..255] of byte;

var
  sn,cs:array[-3599..3599] of single;

procedure drawsurface(surface:tsurface;where:tbmp;col:longint;gint:longint);
var o,tmy:array[0..3] of longint;
    r,v,b:integer;
    i,j,trv,step,temp,y,y1:longint;
    dx1,dx2,x1,x2:longint;
    to1,to2:longint;
    lx1,lx2,ta:longint;
    adr:longword;
    lum,lumr,lumv,lumb:longint;
const prec=65536;
begin
  lum:=surface.int;
  r:=(col shr 16) and 255;
  v:=(col shr 8) and 255;
  b:=(col) and 255;
  lumr:=(lum shr 16) and 255;
  lumv:=(lum shr 8) and 255;
  lumb:=(lum) and 255;
  r:=(r*lumr*gint) shr 16;
  v:=(v*lumv*gint) shr 16;
  b:=(b*lumb*gint) shr 16;
  if r>255 then r:=255;
  if v>255 then v:=255;
  if b>255 then b:=255;
  col:=((r shl 16)+(v shl 8)+b) and andval;

  with surface do begin
    for i:=0 to 3 do begin
      o[i]:=i;
      tmy[i]:=point[i].y;
    end;
    for i:=0 to 2 do begin
      trv:=i;
      for j:=i+1 to 3 do if tmy[j]<tmy[trv] then trv:=j;
      temp:=tmy[i];tmy[i]:=tmy[trv];tmy[trv]:=temp;
      temp:=o[i];o[i]:=o[trv];o[trv]:=temp;
    end;
    y:=point[o[0]].y;
    x1:=point[o[0]].x*prec;
    x2:=x1;
    to1:=o[0]+1;if to1=4 then to1:=0;
    to2:=o[0]-1;if to2=-1 then to2:=3;
    for step:=0 to 2 do begin
      dx1:=0;if y<>point[to1].y then dx1:=(point[to1].x*prec-x1) div (point[to1].y-y) else x1:=point[to1].x*prec;
      dx2:=0;if y<>point[to2].y then dx2:=(point[to2].x*prec-x2) div (point[to2].y-y) else x2:=point[to2].x*prec;
      for y1:=y to point[o[step+1]].y-1 do begin
        if (y1>=0) and (y1<where.ty) then begin
          lx1:=x1 div prec;
          lx2:=x2 div prec;
          if lx1>lx2 then begin
            temp:=lx1;
            lx1:=lx2;
            lx2:=temp;
          end;
          if lx1<0 then lx1:=0;
          if lx2>=where.tx then lx2:=where.tx-1;
          ta:=lx2-lx1+1;
          if ta>0 then begin
            adr:=(lx1+y1*where.pitch) shl 2;
            asm
              push ecx
              push edi
              mov ecx, ta
              mov eax, col
              mov edi, adr
              add edi, where.bmp
              rep stosd
              pop edi
              pop ecx
            end;
          end;
        end;
        inc(x1,dx1);
        inc(x2,dx2);
      end;
      y:=point[o[step+1]].y;
      if y=point[to1].y then begin
        inc(to1);if to1=4 then to1:=0;
      end else begin
        dec(to2);if to2=-1 then to2:=3;
      end;
    end;
  end;
end;

procedure drawsurfaceor1(surface:tsurface;where:tbmp;col:longint;gint:longint);
var o,tmy:array[0..3] of longint;
    r,v,b:word;
    i,j,trv,step,temp,y,y1:longint;
    dx1,dx2,x1,x2:longint;
    to1,to2:longint;
    lx1,lx2,ta:longint;
    adr:longword;
    lum,lumr,lumv,lumb:longint;
const prec=65536;
begin
  lum:=surface.int;
  r:=(col shr 16) and 255;
  v:=(col shr 8) and 255;
  b:=(col) and 255;
  lumr:=(lum shr 16) and 255;
  lumv:=(lum shr 8) and 255;
  lumb:=(lum) and 255;
  r:=(r*lumr*gint) shr 16;
  v:=(v*lumv*gint) shr 16;
  b:=(b*lumb*gint) shr 16;
  if r>255 then r:=255;
  if v>255 then v:=255;
  if b>255 then b:=255;
(*  col:=((r shl 16)+(v shl 8)+b) and andval;*)

  with surface do begin
    for i:=0 to 3 do begin
      o[i]:=i;
      tmy[i]:=point[i].y;
    end;
    for i:=0 to 2 do begin
      trv:=i;
      for j:=i+1 to 3 do if tmy[j]<tmy[trv] then trv:=j;
      temp:=tmy[i];tmy[i]:=tmy[trv];tmy[trv]:=temp;
      temp:=o[i];o[i]:=o[trv];o[trv]:=temp;
    end;
    y:=point[o[0]].y;
    x1:=point[o[0]].x*prec;
    x2:=x1;
    to1:=o[0]+1;if to1=4 then to1:=0;
    to2:=o[0]-1;if to2=-1 then to2:=3;
    for step:=0 to 2 do begin
      dx1:=0;if y<>point[to1].y then dx1:=(point[to1].x*prec-x1) div (point[to1].y-y) else x1:=point[to1].x*prec;
      dx2:=0;if y<>point[to2].y then dx2:=(point[to2].x*prec-x2) div (point[to2].y-y) else x2:=point[to2].x*prec;
      for y1:=y to point[o[step+1]].y-1 do begin
        if (y1>=0) and (y1<where.ty) then begin
          lx1:=x1 div prec;
          lx2:=x2 div prec;
          if lx1>lx2 then begin
            temp:=lx1;
            lx1:=lx2;
            lx2:=temp;
          end;
          if lx1<0 then lx1:=0;
          if lx2>=where.tx then lx2:=where.tx-1;
          ta:=lx2-lx1+1;
          if ta>0 then begin
            adr:=(lx1+y1*where.pitch) shl 2;
            asm
              push ebx
              push ecx
              push edi
              mov ecx, ta
              mov eax, col
              mov edi, adr
              add edi, where.bmp
              xor eax, eax
              mov ebx, offset mixtable
@re:
              cmp byte ptr [edi+ecx*4+3-4],0
              jnz @no
              mov byte ptr [edi+ecx*4+3-4], 1
              mov ax, r
              mov ah, [edi+ecx*4+2-4]
              mov al, [ebx+eax]
              mov [edi+ecx*4+2-4],al

              mov ax, v
              mov ah, [edi+ecx*4+1-4]
              mov al, [ebx+eax]
              mov [edi+ecx*4+1-4],al

              mov ax, b
              mov ah, [edi+ecx*4+0-4]
              mov al, [ebx+eax]
              mov [edi+ecx*4+0-4],al
@no:
              dec ecx
              jnz @re
              pop edi
              pop ecx
              pop ebx
            end;
          end;
        end;
        inc(x1,dx1);
        inc(x2,dx2);
      end;
      y:=point[o[step+1]].y;
      if y=point[to1].y then begin
        inc(to1);if to1=4 then to1:=0;
      end else begin
        dec(to2);if to2=-1 then to2:=3;
      end;
    end;
  end;
end;

procedure drawsurfaceor(surface:tsurface;where:tbmp;col:longint;gint:longint);
var o,tmy:array[0..3] of longint;
    r,v,b:word;
    i,j,trv,step,temp,y,y1:longint;
    dx1,dx2,x1,x2:longint;
    to1,to2:longint;
    lx1,lx2,ta:longint;
    adr:longword;
    lum,lumr,lumv,lumb:longint;
const prec=65536;
begin
  lum:=surface.int;
  r:=(col shr 16) and 255;
  v:=(col shr 8) and 255;
  b:=(col) and 255;
  lumr:=(lum shr 16) and 255;
  lumv:=(lum shr 8) and 255;
  lumb:=(lum) and 255;
  r:=(r*lumr*gint) shr 16;
  v:=(v*lumv*gint) shr 16;
  b:=(b*lumb*gint) shr 16;
  if r>255 then r:=255;
  if v>255 then v:=255;
  if b>255 then b:=255;
(*  col:=((r shl 16)+(v shl 8)+b) and andval;*)

  with surface do begin
    for i:=0 to 3 do begin
      o[i]:=i;
      tmy[i]:=point[i].y;
    end;
    for i:=0 to 2 do begin
      trv:=i;
      for j:=i+1 to 3 do if tmy[j]<tmy[trv] then trv:=j;
      temp:=tmy[i];tmy[i]:=tmy[trv];tmy[trv]:=temp;
      temp:=o[i];o[i]:=o[trv];o[trv]:=temp;
    end;
    y:=point[o[0]].y;
    x1:=point[o[0]].x*prec;
    x2:=x1;
    to1:=o[0]+1;if to1=4 then to1:=0;
    to2:=o[0]-1;if to2=-1 then to2:=3;
    for step:=0 to 2 do begin
      dx1:=0;if y<>point[to1].y then dx1:=(point[to1].x*prec-x1) div (point[to1].y-y) else x1:=point[to1].x*prec;
      dx2:=0;if y<>point[to2].y then dx2:=(point[to2].x*prec-x2) div (point[to2].y-y) else x2:=point[to2].x*prec;
      for y1:=y to point[o[step+1]].y-1 do begin
        if (y1>=0) and (y1<where.ty) then begin
          lx1:=x1 div prec;
          lx2:=x2 div prec;
          if lx1>lx2 then begin
            temp:=lx1;
            lx1:=lx2;
            lx2:=temp;
          end;
          if lx1<0 then lx1:=0;
          if lx2>=where.tx then lx2:=where.tx-1;
          ta:=lx2-lx1+1;
          if ta>0 then begin
            adr:=(lx1+y1*where.pitch) shl 2;
            asm
              push ebx
              push ecx
              push edi
              mov ecx, ta
              mov eax, col
              mov edi, adr
              add edi, where.bmp
              xor eax, eax
              mov ebx, offset mixtable
@re:
              mov ax, r
              mov ah, [edi+ecx*4+2-4]
              mov al, [ebx+eax]
              mov [edi+ecx*4+2-4],al

              mov ax, v
              mov ah, [edi+ecx*4+1-4]
              mov al, [ebx+eax]
              mov [edi+ecx*4+1-4],al

              mov ax, b
              mov ah, [edi+ecx*4+0-4]
              mov al, [ebx+eax]
              mov [edi+ecx*4+0-4],al
              dec ecx
              jnz @re
              pop edi
              pop ecx
              pop ebx
            end;
          end;
        end;
        inc(x1,dx1);
        inc(x2,dx2);
      end;
      y:=point[o[step+1]].y;
      if y=point[to1].y then begin
        inc(to1);if to1=4 then to1:=0;
      end else begin
        dec(to2);if to2=-1 then to2:=3;
      end;
    end;
  end;
end;

procedure pset(x,y:longint;c:longword;where:tbmp);
var adr:longint;
begin
  if (x>=0) and (y>=0) and (x<where.tx) and (y<where.ty) then begin
    adr:=(x+y*where.pitch)*4;
    asm
      push ebx
      push edi
      mov eax, c
      mov ebx, where.bmp
      mov edi, adr
      mov [ebx+edi],eax
      pop edi
      pop ebx
    end;
  end;
end;

procedure findviews(var cube:tcube);
var i,j:integer;
    dx1,dy1,dx2,dy2:longint;
begin
  for i:=0 to 5 do begin
    dx1:=cube.face[i].point[0].x-cube.face[i].point[1].x;
    dy1:=cube.face[i].point[0].y-cube.face[i].point[1].y;
    dx2:=cube.face[i].point[2].x-cube.face[i].point[1].x;
    dy2:=cube.face[i].point[2].y-cube.face[i].point[1].y;
    cube.face[i].viewed:=(dx1*dy2-dx2*dy1)>0;
  end;
  for i:=0 to 11 do begin
    with cube.barre[i] do begin
      viewed:=cube.face[sideface1].viewed or cube.face[sideface2].viewed;
      for j:=0 to cube.barre[i].nfaces-1 do begin
        dx1:=face[j].point[0].x-face[j].point[1].x;
        dy1:=face[j].point[0].y-face[j].point[1].y;
        dx2:=face[j].point[2].x-face[j].point[1].x;
        dy2:=face[j].point[2].y-face[j].point[1].y;
        face[j].viewed:=(dx1*dy2-dx2*dy1)>0;
      end;
    end;
  end;
end;

procedure initfaces(var cube:tcube);
var i,j,k:integer;
begin
  for i:=0 to 5 do begin
    for j:=0 to 3 do begin
      cube.face[i].point[j]:=cube.pntproj[cube.face[i].pnt[j]];
    end;
  end;
  for i:=0 to 11 do begin
    for j:=0 to cube.barre[i].nfaces-1 do begin
      for k:=0 to 3 do begin
        cube.barre[i].face[j].point[k]:=cube.pntproj[cube.barre[i].face[j].pnt[k]];
      end;
    end;
  end;
end;

procedure calcdist(var cube:tcube;w:tworld);
var i,j,trv,tmp:integer;
    max,temp:double;
begin
  for i:=0 to 11 do begin
    cube.order[i]:=i;
    cube.barre[i].dist:=abs(cube.pntrot[cube.barre[i].center].x+w.cx)+abs(cube.pntrot[cube.barre[i].center].y+w.cy)+abs(cube.pntrot[cube.barre[i].center].z+w.cz);
  end;
  for i:=0 to 11 do begin
    max:=cube.barre[i].dist;
    trv:=i;
    for j:=i to 11 do begin
      if cube.barre[j].dist>max then begin
        trv:=j;
        max:=cube.barre[j].dist;
      end;
    end;
    tmp:=cube.order[i];
    cube.order[i]:=cube.order[trv];
    cube.order[trv]:=tmp;
    temp:=cube.barre[i].dist;
    cube.barre[i].dist:=cube.barre[trv].dist;
    cube.barre[trv].dist:=temp;
  end;
end;

procedure projectcube(var cube:tcube;w:tworld;b:tbmp);
var i:integer;
begin
  for i:=0 to 81 do begin
    if cube.pntrot[i].z+w.cx<>0 then begin
      cube.pntproj[i].x:=round((cube.pntrot[i].x+w.cx)*w.zoom/(cube.pntrot[i].z+w.cz)+b.sx);
      cube.pntproj[i].y:=round((cube.pntrot[i].y+w.cy)*w.zoom/(cube.pntrot[i].z+w.cz)+b.sy);
    end else begin
      cube.pntproj[i].x:=b.sx;
      cube.pntproj[i].y:=b.sy;
    end;
  end;
end;

procedure rotatecube(var cube:tcube;w:tworld);
var i:longint;
var tx1,ty1,tz1,tx2,ty2,tz2:single;
begin
  w.a1:=w.a1 mod 3600;
  w.a2:=w.a2 mod 3600;
  w.a3:=w.a3 mod 3600;
  for i:=0 to 40 (*81*) do begin
    {selon x}
    if w.a1<>0 then begin
      tx2:=cube.pnt[i].x;
      ty2:=cube.pnt[i].y*cs[w.a1]-cube.pnt[i].z*sn[w.a1];
      tz2:=cube.pnt[i].z*cs[w.a1]+cube.pnt[i].y*sn[w.a1];
    end else begin
      tx2:=cube.pnt[i].x;
      ty2:=cube.pnt[i].y;
      tz2:=cube.pnt[i].z;
    end;
    {selon y}
    if w.a2<>0 then begin
      tx1:=tx2*cs[w.a2]+tz2*sn[w.a2];
      ty1:=ty2;
      tz1:=tz2*cs[w.a2]-tx2*sn[w.a2];
    end else begin
      tx1:=tx2;
      ty1:=ty2;
      tz1:=tz2;
    end;
    {selon z}
    if w.a3<>0 then begin
      cube.pntrot[i].x:=tx1*cs[w.a3]-ty1*sn[w.a3];
      cube.pntrot[i].y:=ty1*cs[w.a3]+tx1*sn[w.a3];
      cube.pntrot[i].z:=tz1;
    end else begin
      cube.pntrot[i].x:=tx1;
      cube.pntrot[i].y:=ty1;
      cube.pntrot[i].z:=tz1;
    end;
  end;
  w.a1:=w.a1;
  for i:=41 to 81 (*81*) do begin
    {selon x}
    if w.a1<>0 then begin
      tx2:=cube.pnt[i].x;
      ty2:=cube.pnt[i].y*cs[w.a1]-cube.pnt[i].z*sn[w.a1];
      tz2:=cube.pnt[i].z*cs[w.a1]+cube.pnt[i].y*sn[w.a1];
    end else begin
      tx2:=cube.pnt[i].x;
      ty2:=cube.pnt[i].y;
      tz2:=cube.pnt[i].z;
    end;
    {selon y}
    if w.a2<>0 then begin
      tx1:=tx2*cs[w.a2]+tz2*sn[w.a2];
      ty1:=ty2;
      tz1:=tz2*cs[w.a2]-tx2*sn[w.a2];
    end else begin
      tx1:=tx2;
      ty1:=ty2;
      tz1:=tz2;
    end;
    {selon z}
    if w.a3<>0 then begin
      cube.pntrot[i].x:=tx1*cs[w.a3]-ty1*sn[w.a3];
      cube.pntrot[i].y:=ty1*cs[w.a3]+tx1*sn[w.a3];
      cube.pntrot[i].z:=tz1;
    end else begin
      cube.pntrot[i].x:=tx1;
      cube.pntrot[i].y:=ty1;
      cube.pntrot[i].z:=tz1;
    end;
  end;
end;


procedure setpos(var cube:tcube;n:integer;x,y,z:longint);
begin
  cube.pnt[n].x:=x;
  cube.pnt[n].y:=y;
  cube.pnt[n].z:=z;
end;

procedure setface(var cube:tcube;nbarre,nface,p1,p2,p3,p4:integer;dr:integer;int:longint);
begin
  if dr=1 then begin
    cube.barre[nbarre].face[nface].pnt[0]:=p1;
    cube.barre[nbarre].face[nface].pnt[1]:=p2;
    cube.barre[nbarre].face[nface].pnt[2]:=p3;
    cube.barre[nbarre].face[nface].pnt[3]:=p4;
  end else begin
    cube.barre[nbarre].face[nface].pnt[3]:=p1;
    cube.barre[nbarre].face[nface].pnt[2]:=p2;
    cube.barre[nbarre].face[nface].pnt[1]:=p3;
    cube.barre[nbarre].face[nface].pnt[0]:=p4;
  end;
  cube.barre[nbarre].face[nface].int:=int;
end;

procedure initcube(var cube:tcube;cubea,cubeb:integer);
var i:integer;
begin
  (*les points*)
  setpos(cube,0,cubea,cubea,cubea);
  setpos(cube,1,cubea-cubeb,cubea,cubea);
  setpos(cube,2,cubea-cubeb,cubea-cubeb,cubea);
  setpos(cube,3,cubea,cubea-cubeb,cubea);
  setpos(cube,4,cubea,cubea,cubea-cubeb);
  setpos(cube,5,cubea-cubeb,cubea,cubea-cubeb);
  setpos(cube,6,cubea-cubeb,cubea-cubeb,cubea-cubeb);
  setpos(cube,7,cubea,cubea-cubeb,cubea-cubeb);
  for i:=0 to 7 do begin
    setpos(cube,08+i,-cube.pnt[i].x,-cube.pnt[i].y,-cube.pnt[i].z);
    setpos(cube,16+i,+cube.pnt[i].x,-cube.pnt[i].y,-cube.pnt[i].z);
    setpos(cube,24+i,+cube.pnt[i].x,+cube.pnt[i].y,-cube.pnt[i].z);
    setpos(cube,32+i,-cube.pnt[i].x,+cube.pnt[i].y,-cube.pnt[i].z);
    setpos(cube,40+i,+cube.pnt[i].x,-cube.pnt[i].y,+cube.pnt[i].z);
    setpos(cube,48+i,-cube.pnt[i].x,+cube.pnt[i].y,+cube.pnt[i].z);
    setpos(cube,56+i,-cube.pnt[i].x,-cube.pnt[i].y,+cube.pnt[i].z);
  end;
  setpos(cube,64,0,-cubea+(cubeb div 2),-cubea+(cubeb div 2));
  setpos(cube,65,-cubea+(cubeb div 2),0,-cubea+(cubeb div 2));
  setpos(cube,66,0,+cubea-(cubeb div 2),-cubea+(cubeb div 2));
  setpos(cube,67,+cubea-(cubeb div 2),0,-cubea+(cubeb div 2));

  setpos(cube,68,0,-cubea+(cubeb div 2),+cubea-(cubeb div 2));
  setpos(cube,69,-cubea+(cubeb div 2),0,+cubea-(cubeb div 2));
  setpos(cube,70,0,+cubea-(cubeb div 2),+cubea-(cubeb div 2));
  setpos(cube,71,+cubea-(cubeb div 2),0,+cubea-(cubeb div 2));

  setpos(cube,72,+cubea-(cubeb div 2),+cubea-(cubeb div 2),0);
  setpos(cube,73,+cubea-(cubeb div 2),-cubea+(cubeb div 2),0);
  setpos(cube,74,-cubea+(cubeb div 2),-cubea+(cubeb div 2),0);
  setpos(cube,75,-cubea+(cubeb div 2),+cubea-(cubeb div 2),0);

  setpos(cube,76,0,0,64);
  setpos(cube,77,0,0,-64);
  setpos(cube,78,0,64,0);
  setpos(cube,79,0,-64,0);
  setpos(cube,80,64,0,0);
  setpos(cube,81,-64,0,0);
  (*les 6 surfaces de base*)
  cube.face[0].pnt[0]:=32;
  cube.face[0].pnt[1]:=24;
  cube.face[0].pnt[2]:=16;
  cube.face[0].pnt[3]:=8;

  cube.face[1].pnt[3]:=56;
  cube.face[1].pnt[2]:=48;
  cube.face[1].pnt[1]:=0;
  cube.face[1].pnt[0]:=40;

  cube.face[2].pnt[0]:=8;
  cube.face[2].pnt[1]:=16;
  cube.face[2].pnt[2]:=40;
  cube.face[2].pnt[3]:=56;

  cube.face[3].pnt[0]:=0;
  cube.face[3].pnt[1]:=24;
  cube.face[3].pnt[2]:=32;
  cube.face[3].pnt[3]:=48;

  cube.face[4].pnt[3]:=8;
  cube.face[4].pnt[2]:=32;
  cube.face[4].pnt[1]:=48;
  cube.face[4].pnt[0]:=56;

  cube.face[5].pnt[0]:=0;
  cube.face[5].pnt[1]:=40;
  cube.face[5].pnt[2]:=16;
  cube.face[5].pnt[3]:=24;

  (*les surfaces des 12barres*)
  (*du coin 8  16*)
  cube.barre[0].nfaces:=7;
  cube.barre[0].sideface1:=0;
  cube.barre[0].sideface2:=2;
  cube.barre[0].center:=64;
  setface(cube,0,0,9,10,18,17,1,$707070);
  setface(cube,0,1,17,21,13,9,1,$707070);
  setface(cube,0,2,14,13,21,22,1,$ffffff);
  setface(cube,0,3,22,18,10,14,1,$ffffff);
  setface(cube,0,4,8,11,10,9,1,$a0a0a0);
  setface(cube,0,5,16,20,21,17,1,$a0a0a0);
  setface(cube,0,6,13,9,8,12,-1,$a0a0a0);
  (*du coin 8  32*)
  cube.barre[1].nfaces:=7;
  cube.barre[1].sideface1:=0;
  cube.barre[1].sideface2:=4;
  cube.barre[1].center:=65;
  setface(cube,1,0,10,11,35,34,1,$707070);
  setface(cube,1,1,34,38,14,10,1,$ffffff div 1);
  setface(cube,1,2,15,14,38,39,1,$ffffff div 1);
  setface(cube,1,3,39,35,11,15,1,$707070);
  setface(cube,1,4,33,32,35,34,-1,$a0a0a0);
  setface(cube,1,5,36,32,35,39,1,$a0a0a0);
  setface(cube,1,6,8,12,15,11,1,$a0a0a0);
  (*du coin 32  24*)
  cube.barre[2].nfaces:=7;
  cube.barre[2].sideface1:=0;
  cube.barre[2].sideface2:=3;
  cube.barre[2].center:=66;
  setface(cube,2,0,25,26,34,33,1,$707070);
  setface(cube,2,1,33,37,29,25,1,$707070);
  setface(cube,2,2,30,29,37,38,1,$ffffff div 1);
  setface(cube,2,3,38,34,26,30,1,$ffffff div 1);
  setface(cube,2,4,24,27,26,25,1,$a0a0a0);
  setface(cube,2,5,32,36,37,33,1,$a0a0a0);
  setface(cube,2,6,28,24,25,29,1,$a0a0a0);
  (*du coin 24  16*)
  cube.barre[3].nfaces:=7;
  cube.barre[3].sideface1:=0;
  cube.barre[3].sideface2:=5;
  cube.barre[3].center:=67;
  setface(cube,3,0,26,27,19,18,1,$707070);
  setface(cube,3,1,18,22,30,26,1,$ffffff div 1);
  setface(cube,3,2,31,30,22,23,1,$ffffff div 1);
  setface(cube,3,3,23,19,27,31,1,$707070);
  setface(cube,3,4,16,17,18,19,1,$a0a0a0);
  setface(cube,3,5,20,16,19,23,1,$a0a0a0);
  setface(cube,3,6,24,28,31,27,1,$a0a0a0);
  (*du coin 0  40*)
  cube.barre[4].nfaces:=7;
  cube.barre[4].sideface1:=1;
  cube.barre[4].sideface2:=5;
  cube.barre[4].center:=71;
  setface(cube,4,0,42,43,3,2,1,$707070);
  setface(cube,4,1,2,6,46,42,1,$ffffff div 1);
  setface(cube,4,2,47,46,6,7,1,$ffffff div 1);
  setface(cube,4,3,7,3,43,47,1,$707070);
  setface(cube,4,4,41,40,43,42,1,$a0a0a0);
  setface(cube,4,5,4,0,3,7,1,$a0a0a0);
  setface(cube,4,6,40,44,47,43,1,$a0a0a0);
  (*du coin 40  56*)
  cube.barre[5].nfaces:=7;
  cube.barre[5].sideface1:=1;
  cube.barre[5].sideface2:=2;
  cube.barre[5].center:=68;
  setface(cube,5,0,41,42,58,57,1,$707070);
  setface(cube,5,1,57,61,45,41,1,$707070);
  setface(cube,5,2,46,45,61,62,1,$ffffff div 1);
  setface(cube,5,3,62,58,42,46,1,$ffffff div 1);
  setface(cube,5,4,59,56,57,58,1,$a0a0a0);
  setface(cube,5,5,56,60,61,57,1,$a0a0a0);
  setface(cube,5,6,44,40,41,45,1,$a0a0a0);
  (*du coin 56  48*)
  cube.barre[6].nfaces:=7;
  cube.barre[6].sideface1:=1;
  cube.barre[6].sideface2:=4;
  cube.barre[6].center:=69;
  setface(cube,6,0,50,51,59,58,1,$707070);
  setface(cube,6,1,58,62,54,50,1,$ffffff div 1);
  setface(cube,6,2,55,54,62,63,1,$ffffff div 1);
  setface(cube,6,3,63,59,51,55,1,$707070);
  setface(cube,6,4,49,48,51,50,1,$a0a0a0);
  setface(cube,6,5,60,56,59,63,1,$a0a0a0);
  setface(cube,6,6,48,52,55,51,1,$a0a0a0);
  (*du coin 48  0*)
  cube.barre[7].nfaces:=7;
  cube.barre[7].sideface1:=1;
  cube.barre[7].sideface2:=3;
  cube.barre[7].center:=70;
  setface(cube,7,0,49,50,2,1,1,$707070);
  setface(cube,7,1,49,53,5,1,-1,$707070);
  setface(cube,7,2,54,53,5,6,1,$ffffff div 1);
  setface(cube,7,3,54,50,2,6,-1,$ffffff div 1);

  setface(cube,7,4,3,0,1,2,1,$a0a0a0);
  setface(cube,7,5,48,52,53,49,-1,$a0a0a0);
  setface(cube,7,6,4,0,1,5,-1,$a0a0a0);
  (*du coin 0  24*)
  cube.barre[8].nfaces:=4;
  cube.barre[8].sideface1:=3;
  cube.barre[8].sideface2:=5;
  cube.barre[8].center:=72;
  setface(cube,8,0,6,7,31,30,-1,$ffffff div 1);
  setface(cube,8,1,6,5,29,30,1,$ffffff div 1);
  setface(cube,8,2,4,5,29,28,-1,$707070);
  setface(cube,8,3,4,7,31,28,1,$707070);
  (*du coin 40  16*)
  cube.barre[9].nfaces:=4;
  cube.barre[9].sideface1:=2;
  cube.barre[9].sideface2:=5;
  cube.barre[9].center:=73;
  setface(cube,9,0,46,47,23,22,1,$ffffff div 1);
  setface(cube,9,1,46,45,21,22,-1,$ffffff div 1);
  setface(cube,9,2,44,45,21,20,1,$707070);
  setface(cube,9,3,44,47,23,20,-1,$707070);
  (*du coin 56  8*)
  cube.barre[10].nfaces:=4;
  cube.barre[10].sideface1:=2;
  cube.barre[10].sideface2:=4;
  cube.barre[10].center:=74;
  setface(cube,10,0,62,63,15,14,-1,$ffffff div 1);
  setface(cube,10,1,62,61,13,14,1,$ffffff div 1);
  setface(cube,10,2,60,61,13,12,-1,$707070);
  setface(cube,10,3,60,63,15,12,1,$707070);
  (*du coin 48  32*)
  cube.barre[11].nfaces:=4;
  cube.barre[11].sideface1:=3;
  cube.barre[11].sideface2:=4;
  cube.barre[11].center:=75;
  setface(cube,11,0,54,55,39,38,1,$ffffff div 1);
  setface(cube,11,1,54,53,37,38,-1,$ffffff div 1);
  setface(cube,11,2,52,53,37,36,1,$707070);
  setface(cube,11,3,52,55,39,36,-1,$707070);
end;


procedure drawtrans(cube:tcube;bitmap:tbmp;col,int:longword);
var i,j:integer;
begin
  for j:=0 to 11 do begin
    for i:=0 to cube.barre[j].nfaces-1 do drawsurfaceor(cube.barre[j].face[i],bitmap,col,int);
  end;
end;

procedure drawback(cube:tcube;bitmap:tbmp;col,int:longword);
var i,j:integer;
begin
  for j:=0 to 11 do begin
    if not cube.barre[cube.order[j]].viewed then for i:=0 to cube.barre[cube.order[j]].nfaces-1 do if cube.barre[cube.order[j]].face[i].viewed then drawsurfaceor1(cube.barre[cube.order[j]].face[i],bitmap,col,int);
  end;
end;

procedure drawfront(cube:tcube;bitmap:tbmp;col,int:longword);
var i,j:integer;
begin
  for j:=0 to 11 do begin
    if cube.barre[cube.order[j]].viewed then for i:=0 to cube.barre[cube.order[j]].nfaces-1 do if cube.barre[cube.order[j]].face[i].viewed then drawsurface(cube.barre[cube.order[j]].face[i],bitmap,col,int);
  end;
end;

procedure performcube(var cube:tcube;world:tworld;bitmap:tbmp);
begin
  rotatecube(cube,world);
  projectcube(cube,world,bitmap);
  initfaces(cube);
  findviews(cube);
  calcdist(cube,world);
end;

procedure initmix;
var i,j:integer;
    k:integer;
begin
  for i:=0 to 255 do begin
    for j:=0 to 255 do begin
      k:=i+j;
      if k>255 then k:=255;
      mixtable[i,j]:=k;
    end;
  end;
end;

procedure inittrigo;
var i:integer;
begin
  for i:=-3599 to 3599 do begin
    cs[i]:=cos(i/10*pi/180);
    sn[i]:=sin(i/10*pi/180);
  end;
end;

begin
  inittrigo;
  initmix;
end.
