library vis1;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes,
  windows,
  newutils,
  visgraphs,
  vispattern,
  forms,
  skin;

Var InfoStr:String;
    dir:string;

Const Version=1 SHL 16+72;

procedure ClearPattern(hn:hwnd);stdcall
begin
  clearpatt(hn);
end;

procedure ClearVis(hn:hwnd);stdcall
begin
  clearv(hn);
end;

procedure InitPattern(hn:hwnd;tx,ty:LongWord);stdcall
begin
  initpatt(hn,tx,ty);
end;

procedure UnInitPattern;stdcall
begin
  uninitpatt;
end;

procedure DoPattern(hn:hwnd;pos:byte;pl:boolean);stdcall
begin
  dopatt(hn,pos,pl and (pmod.getmod(24)=0),pmod);
end;

procedure InitVis(hn:hwnd;tx,ty:longword);stdcall
begin
  initv(hn,tx,ty,false);
end;

procedure UnInitVis;stdcall
begin
  uninitv;
end;

procedure DoVis(hn:hwnd;pl:boolean);stdcall
begin
  dov(hn,pl and (pmod.getmod(24)=0),pmod);
end;

Function GetInfo(Param:LongWord):LongInt;stdcall
Begin
  GetInfo:=-1;
  Case Param Of
    (*get nchan*)
    1:Begin
      GetInfo:=NChan;
    End;
    (*get requested pmp version*)
    2:Begin
      GetInfo:=Version;
    End;
  End;
End;

procedure NewPlay;stdcall
begin
end;

function GetInfoStr:pstring;
begin
  getinfostr:=@infostr;
end;

procedure GlobalInit(LoadProc:TLoadProc);stdcall;
begin
  loadallstuff(loadproc);
  dir:=pmod.getstring(1);
  visinit;
end;

procedure GlobalUnInit;stdcall;
begin
  visuninit;
end;

procedure SetupVis;stdcall;
begin
  setupv;
end;

procedure SetupPattern;stdcall
begin
end;

exports
  NewPlay index 1,
  InitVis index 2,
  UnInitVis index 3,
  DoVis index 4,
  InitPattern index 5,
  UnInitPattern index 6,
  DoPattern index 7,
  ClearPattern index 8,
  ClearVis index 9,
  GetInfo index 10,
  GetInfoStr index 11,
  GlobalInit index 12,
  GlobalUnInit index 13,
  SetupVis Index 14,
  SetupPattern Index 15;

begin
  infostr:='Another Plugin for PMP by Plouf';
end.
