{$DEFINE DDraw}
{*$UNDEF DDraw}

unit visgraphs;

interface
uses skin,
     windows,
{$IFDEF DDraw}
     forms,
     classes,
     menus,
     controls,
     registry,
     ddraw,
{$ENDIF}
     cubeunit;

procedure clearv(hn:hwnd);
procedure InitV(hn:hwnd;tx,ty:longword;full:boolean);
procedure UnInitV;
procedure DoV(hn:hwnd;pl:boolean;pmod:tpmod);
procedure visinit;
procedure visuninit;
procedure setupv;

implementation

const andval=16579836;

const resx:array[0..5] of integer=(320,320,400,512,640,640);
const resy:array[0..5] of integer=(200,240,300,384,400,480);

{$IFDEF DDraw}
type tmyform=record
  form:tform;
  popup:tpopupmenu;
  full:tmenuitem;
  res1,res2,res3,res4,res5,res6:tmenuitem;
  nil1:tmenuitem;
end;

var myform:tmyform;

var lpdd:idirectdraw;
    surface:IDirectDrawSurface;
var ddform:tform;
Var Bpp:Byte;
{$ENDIF}

Var OldTx,OldTy:Integer;


Var OldImage,Image,H:HWnd;
Var PBitmap:Pointer;
Var Txd,Tyd:LongInt;
    Txdd,Tydd:LongInt;
Var Mode:integer;

const np=100;

Var A1,A2,A3,Ab:Integer;
var sn,cs:array[-3599..3599] of single;
    colangle:longword;
    px,py:array[1..np] of integer;
    used:array[1..np] of boolean;
    lv:longint;
    vc:integer;

var pfrom,pto:pointer;
    pimg1,pimg2:pointer;

Var Table1,Table2,Screen1,Screen2,Screen3:Pointer;

Var Col1,Col2,Col3,Col4,Col5,Col6,Col7:LongWord;

Type TPnt=Record
  X,Y,Z:Integer;
End;

Var Titre:Array[1..31] Of TPnt;
    Field:Array[1..200] Of TPnt;

Var WaitingForReinit:Boolean;

Const Tai=9;
      NTai=1 SHL 9;

Var Init:Boolean;
    LastTick:LongWord;

    Show:Byte;

Var ResIndex:Byte;

Var Delai:Word;

var cube:tcube;
    world:tworld;
    bitmap:tbmp;

{$IFDEF DDraw}
procedure loadreg;
var reg:tregistry;
begin
  reg:=TRegistry.Create;
  reg.OpenKey('Software',False);
  reg.OpenKey('PMPlayer',True);
  reg.OpenKey('Vis1',True);
  resindex:=0;
  if reg.valueexists('ResIndex') then resindex:=reg.readinteger('ResIndex') else reg.writeinteger('ResIndex',resindex);
  reg.CloseKey;
  reg.Destroy;
end;

procedure savereg;
var reg:tregistry;
begin
  reg:=TRegistry.Create;
  reg.OpenKey('Software',False);
  reg.OpenKey('PMPlayer',True);
  reg.OpenKey('Vis1',True);
  reg.writeinteger('ResIndex',resindex);
  reg.CloseKey;
  reg.Destroy;
end;
{$ENDIF}

function getech:integer;
begin
  getech:=trunc(tyd*100/200);
end;

{$IFDEF DDraw}
function initdraw:boolean;
var ddsd:TDDSURFACEDESC;
begin
  initdraw:=false;
  if directdrawcreate(nil,lpdd,nil)<>dd_ok then exit;
  if lpdd.SetCooperativeLevel(ddform.handle,DDSCL_EXCLUSIVE OR DDSCL_FULLSCREEN)<>dd_ok then exit;
  bpp:=32;
  if lpdd.SetDisplayMode(txd,tyd,bpp)<>dd_ok then begin
    bpp:=16;
    if lpdd.SetDisplayMode(txd,tyd,bpp)<>dd_ok then begin
      lpdd:=nil;
      exit;
    end;
  end;
  ddsd.dwSize:=sizeof(ddsd);
  ddsd.dwflags:=ddsd_caps;
  ddsd.ddscaps.dwcaps:=ddscaps_primarysurface;
  if lpdd.CreateSurface(ddsd,surface,nil)<>dd_ok then begin
    lpdd:=nil;
    exit;
  end;
  ddform.WindowState:=wsmaximized;
  ddform.show;
  initdraw:=true;
  showcursor(false);
end;

procedure uninitdraw;
begin
  ddform.hide;
  lpdd.restoredisplaymode;
  showcursor(true);
  surface:=nil;
  lpdd:=nil;
end;
{$ENDIF}

procedure clearv(hn:hwnd);
begin
  if mode<4 then begin
    fillchar(pbitmap^,txd*tyd*4,0);
    fillchar(screen1^,txd*tyd*4,0);
    fillchar(screen2^,txd*tyd*4,0);
    fillchar(screen3^,txd*tyd*4,0);
    bitblt(hn,0,0,txd,tyd,H,0,0,SRCCOPY);
  end;
end;

procedure ddkp(Sender: TObject; var Key: Char);
begin
  uninitv;
  waitingforreinit:=true;
end;

procedure inittitre;
var i:integer;
begin
  for i:=1 to 31 do titre[i].z:=0;
  for i:=1 to 5 do begin
    titre[i].x:=-5;
    titre[i].y:=i-3;
  end;
  titre[6].x:=-4;
  titre[6].y:=-2;
  titre[7].x:=-4;
  titre[7].y:=-0;
  for i:=0 to 2 do begin
    titre[8+i].x:=-3;
    titre[8+i].y:=i-2;
  end;

  for i:=0 to 4 do begin
    titre[11+i].x:=-1;
    titre[11+i].y:=i-2;
    titre[16+i].x:=1;
    titre[16+i].y:=i-2;
  end;
  titre[21].x:=0;
  titre[21].y:=-1;
  for i:=22 to 31 do begin
    titre[i].x:=titre[i-21].x+8;
    titre[i].y:=titre[i-21].y;
  end;

  for i:=-3599 to 3599 do begin
    cs[i]:=cos(i/10*pi/180);
    sn[i]:=sin(i/10*pi/180);
  end;

  colangle:=0;

  a1:=0;
  a2:=0;
  a3:=0;
  ab:=0;

  for i:=1 to np do used[i]:=false;
  lv:=0;

  vc:=random(10)+1;

  for i:=1 to 50*getech div 100 do begin
    field[i].x:=random(txd+(80*getech) div 100);
    dec(field[i].x,(40*getech) div 100);
    field[i].y:=random(tyd+(80*getech) div 100);
    dec(field[i].y,(40*getech) div 100);
  end;
  initcube(cube,100,20);
  world.a1:=0;world.a2:=0;world.a3:=0;
  world.cx:=0;world.cy:=0;world.cz:=500;
end;

procedure InitV(hn:hwnd;tx,ty:longword;full:boolean);
var bminfo:tagbitmapinfo;
    nx,ny,x,y:longint;
    r:word;
label re;
begin
  if init then exit;
re:
  txd:=tx;
  tyd:=ty;
  txdd:=txd div 2;
  tydd:=tyd div 2;
  mode:=1;
  if (txd=320) and (tyd=200) then mode:=3;
  if (txd=320) and (tyd<>200) then mode:=2;
  if full then mode:=4;

  getmem(screen1,(tyd+3)*(txd)*4);
  getmem(screen2,(tyd+3)*(txd)*4);
  getmem(screen3,(tyd+3)*(txd)*4);
  getmem(table1,(tyd)*(txd)*4);
  getmem(table2,(tyd)*(txd)*4);

  fillchar(screen1^,(tyd+3)*(txd)*4,0);
  fillchar(screen2^,(tyd+3)*(txd)*4,0);
  fillchar(screen3^,(tyd+3)*(txd)*4,0);

  for x:=0 to txd-1 do begin
    for y:=0 to tyd-1 do begin
      r:=random(3);
      nx:=round(((x-txdd+1)*100/98)+txdd-1+(r-1)/6);
      ny:=round(((y-tydd+1)*100/98)+tydd-1+(r-1)/6);
      if (nx<1) or (ny<1) or (nx>txd-2) or (ny>tyd-2) then begin
        nx:=0;
        ny:=tyd+1;
      end;
      longword(pointer(longint(table1)+x*4+y*txd*4)^):=(nx+ny*txd)*4;

      nx:=round(((x-txdd+1)*90/100)+txdd-1+(r-1)/6);
      ny:=round(((y-tydd+1)*90/100)+tydd-1+(r-1)/6);
      if (nx<1) or (ny<1) or (nx>txd-2) or (ny>tyd-2) then begin
        nx:=0;
        ny:=tyd+1;
      end;
      longword(pointer(longint(table2)+x*4+y*txd*4)^):=(nx+ny*txd)*4;
    end;
  end;
  pimg1:=screen1;
  pimg2:=screen2;

  if mode<4 then begin
    oldtx:=tx;
    oldty:=ty;
    bminfo.bmiHeader.bisize:=sizeof(tagBITMAPINFOHEADER);
    bminfo.bmiHeader.biwidth:=txd;
    bminfo.bmiHeader.biheight:=-tyd;
    bminfo.bmiHeader.biplanes:=1;
    bminfo.bmiHeader.biBitCount:=32;
    bminfo.bmiHeader.bicompression:=bi_rgb;
    bminfo.bmiHeader.bisizeimage:=0;
    bminfo.bmiHeader.biXPelsPerMeter:=0;
    bminfo.bmiHeader.biYPelsPerMeter:=0;
    bminfo.bmiHeader.biclrused:=0;
    bminfo.bmiHeader.biClrImportant:=0;

    h:=CreateCompatibleDC(hn);
    image:=createdibsection(0,bminfo,DIB_RGB_COLORS,pbitmap,0,0);
    oldimage:=selectobject(h,image);
  end else begin
{$IFDEF DDraw}
    ddform.KeyPreview:=true;
    @ddform.onkeypress:=@ddkp;
    if not initdraw then begin
      full:=false;
      goto re;
    end;
{$ENDIF}
  end;

  world.zoom:=2*getech;
  bitmap.tx:=txd;
  bitmap.ty:=tyd;
  bitmap.sx:=txd div 2-1;
  bitmap.sy:=tyd div 2-1;
  bitmap.pitch:=bitmap.tx;

  if not full then clearv(hn);
  inittitre;
  init:=true;
  lasttick:=gettickcount;
end;

procedure UnInitV;
begin
  if not init then exit;
  if mode<4 then begin
    selectobject(h,oldimage);
    deleteobject(image);
    deletedc(h);
  end else begin
{$IFDEF DDraw}
    uninitdraw;
{$ENDIF}
  end;
  init:=false;
end;

procedure pset(x,y:integer;c:longword;where:pointer);
begin
  if (x<0) or (y<0) or (x>txd-1) or (y>tyd-1) then exit;
  longword(pointer((x+y*txd)*4+longint(where))^):=c;
end;

procedure tpset(x,y:integer;where:pointer);
var c:longword;
var r,v,b:integer;
begin
  if (x<0) or (y<0) or (x>txd-1) or (y>tyd-1) then exit;
  c:=longword(pointer((x+y*txd)*4+longint(where))^);
  r:=c shr 16;
  v:=(c shr 8) and $ff;
  b:=c and $ff;
  dec(r,10);if r<0 then r:=0;
  dec(v,10);if v<0 then v:=0;
  dec(b,10);if b<0 then b:=0;
  longword(pointer((x+y*txd)*4+longint(where))^):=((r shl 16)+(v shl 8)+b) and andval;
end;


procedure lpset(x,y:integer;c:longword;where:pointer;b:integer);
var i,j:integer;
begin
  for i:=1 to 2*b do
    for j:=1 to 2*b do
      pset(x+i-1-b div 2,y+j-1-b div 2,c,where);
end;

procedure ltpset(x,y:integer;where:pointer;b:integer);
var i,j:integer;
begin
  for i:=1 to 2*b do
    for j:=1 to 2*b do
      tpset(x+i-1-b div 2,y+j-1-b div 2,where);
end;


procedure showtitre;
var i:integer;
var tx1,ty1,tz1,tx2,ty2,tz2:single;
    nx,ny:integer;
begin
  for i:=1 to 31 do begin
    tx2:=titre[i].x;
    ty2:=titre[i].y*cs[a1]-titre[i].z*sn[a1];
    tz2:=titre[i].z*cs[a1]+titre[i].y*sn[a1];

    tx1:=tx2*cs[a2]+tz2*sn[a2];
    ty1:=ty2;
    tz1:=tz2*cs[a2]-tx2*sn[a2];

    tx2:=tx1*cs[a3]-ty1*sn[a3];
    ty2:=ty1*cs[a3]+tx1*sn[a3];
    tz2:=tz1;

    nx:=round(getech*6*tx2/(tz2+50)+txdd-1);
    ny:=round(getech*6*ty2/(tz2+50)+tydd-1);

    lpset(nx,ny,col3,pfrom,1);
  end;

  a1:=(a1+4) mod 3600;
  a2:=(a2-4) mod 3600;
  a3:=(a3+8) mod 3600;
end;

function gen(angle:integer):integer;
var rep:integer;
begin
  rep:=trunc((30*abs(sin(angle*vc*pi/1800))+50*abs(cos(angle*vc*pi/1700))+60*abs(sin(angle*vc*pi/1900))+180*abs(cos(angle*vc*pi/2000))));
  if rep>255 then rep:=255;
  gen:=rep;
end;

procedure DoV(hn:hwnd;pl:boolean;pmod:tpmod);
var pntr,ptable:pointer;
    r,v,b,i,j,x,y,vx,vy:integer;
    y1,y2:word;
    l:longint;
    vl,vr:longint;
    maxp:integer;

{$IFDEF DDraw}
    surfacedesc:tddsurfacedesc;
    var sb:longword;
{$ENDIF}

    var temp:pointer;

    toscreen:pointer;

label nop;

begin
  if waitingforreinit then begin
    initv(hn,oldtx,oldty,false);
    waitingforreinit:=false;
  end;
  pfrom:=pimg1;
  pto:=pimg2;
  toscreen:=pto;
  If Not Pl Then Goto Nop;
  r:=gen(colangle);
  v:=gen(colangle+1200);
  b:=gen(colangle+2400);
  col1:=(r+(v shl 8)+(b shl 16)) and andval;
  col2:=(v+(b shl 8)+(r shl 16)) and andval;
  col3:=(b+(r shl 8)+(v shl 16)) and andval;
  r:=gen(colangle+900);
  v:=gen(colangle+1200+900);
  b:=gen(colangle+2400+900);
  col4:=(r+(v shl 8)+(b shl 16)) and andval;
  col5:=(v+(b shl 8)+(r shl 16)) and andval;
  col6:=(b+(r shl 8)+(v shl 16)) and andval;
  col7:=$00ffffff and andval;
  inc(colangle);

  if (gettickcount-lasttick) div 1000>=Delai then begin
    i:=show;
    repeat show:=random(8) until (show<>i);
    lasttick:=gettickcount;
  end;
  case show of
    (*oiseau*)
    0,4:begin
      if show=0 then ptable:=table1 else ptable:=table2;
      if show=4 then ltpset(txdd-1,tydd-1,pfrom,1);
      toscreen:=pto;
      if (PMod.getmod(21)=1) and (pmod.getmod(12)=1) then begin
        pntr:=ptr(PMod.getmod(20)+((PMod.getmod(17) shr (tai+2)) shl (tai+2)));
        if pntr<>nil then begin
          vl:=0;vr:=0;
          for i:=0 to 255 do begin
            asm
              pushad
              mov edi, pntr
              mov ebx, i
              shl ebx, 2
              movsx eax, word ptr [ebx+edi]
              add vl, eax
              movsx eax, word ptr [ebx+edi+4]
              sub vl, eax
              movsx eax, word ptr [ebx+edi+2]
              add vr, eax
              movsx eax, word ptr [ebx+edi+6]
              sub vr, eax
              popad
            end;
          end;
        end;
      end;

      if abs(vl)+abs(vr)>vl then lv:=abs(vl)+abs(vr);
      dec(lv,3);
      if lv<0 then lv:=0;

      maxp:=lv div 2500;
      lv:=abs(vl)+abs(vr);

      for i:=1 to np do begin
        if not used[i] and (maxp>0) then begin
          dec(maxp);
          used[i]:=true;
          px[i]:=(random(20)*getech div 100+txdd-31*getech div 100);
          py[i]:=(random(20)*getech div 100+tydd-31*getech div 100);
          if random(2)=1 then px[i]:=txd-1-px[i];
          if random(2)=1 then py[i]:=tyd-1-py[i];
        end;
      end;

      for i:=1 to np do begin
        if used[i] then begin
          vx:=((txdd-1-px[i]) div 10);
          vy:=((tydd-1-py[i]) div 10);
          if vx=0 then vx:=integer(random(7))-3;
          if vy=0 then vy:=integer(random(7))-3;
          dec(px[i],vx);
          dec(py[i],vy);
          if (px[i]<0) or (py[i]<0) or (px[i]>txd-1) or (py[i]>tyd-1) then begin
            used[i]:=false;
          end else begin
            lpset(px[i],py[i],col1,pfrom,2);
          end;
        end;
      end;

      for i:=0 to 8 do begin
        x:=(i*10*getech div 100)+txdd-1;
        y:=round(((-i*4+20*sn[(ab+(8-i)*150) mod 3600])*getech/100+tydd+10*getech/100));
        lpset(x,y,col3,pfrom,2);
        lpset(txd-1-x,y,col3,pfrom,2);
      end;

      ab:=(ab+10) mod 3600;
    end;
    (*ondes*)
    1,5:begin
      if show=1 then ptable:=table1 else ptable:=table2;
      if show=5 then ltpset(txdd-1,tydd-1,pfrom,1);
      toscreen:=pto;
      if (PMod.getmod(21)=1) and (pmod.getmod(12)=1) then begin
        pntr:=ptr(PMod.getmod(20)+((PMod.getmod(17) shr (tai+2)) shl (tai+2)));
        if pntr<>nil then begin
          y1:=(tyd div 4)+9;
          y2:=tyd-1-y1;
          for i:=0 to txd-1 do begin
            j:=512*i div txd;
            y:=integer(pointer(longint(pntr)+j*4)^) and 65535;
            if y>32767 then dec(y,65536);
            y:=y*getech div 51200;

            if (y+y1>0) and (y+y1<tyd-1) then begin
              longword(pointer(longint(pfrom)+((y+y1-1)*txd+i)*4)^):=col1;
              longword(pointer(longint(pfrom)+((y+y1)*txd+i)*4)^):=col1;
              longword(pointer(longint(pfrom)+((y+y1+1)*txd+i)*4)^):=col1;
            end;

            y:=integer(pointer(longint(pntr)+j*4+2)^) and 65535;
            if y>32767 then dec(y,65536);
            y:=y*getech div 51200;

            if (y+y2>0) and (y+y2<tyd-1) then begin
              longword(pointer(longint(pfrom)+((y+y2-1)*txd+i)*4)^):=col2;
              longword(pointer(longint(pfrom)+((y+y2)*txd+i)*4)^):=col2;
              longword(pointer(longint(pfrom)+((y+y2+1)*txd+i)*4)^):=col2;
            end;
          end;

        end;
      end;
      showtitre;
    end;
    (*rond*)
    2,6:begin
      if show=2 then ptable:=table1 else ptable:=table2;
      if show=6 then ltpset(txdd-1,tydd-1,pfrom,1);
      toscreen:=pto;
      if (PMod.getmod(21)=1) and (pmod.getmod(12)=1) then begin
        pntr:=ptr(PMod.getmod(20)+((PMod.getmod(17) shr (tai+2)) shl (tai+2)));
        if pntr<>nil then begin
          for i:=0 to 359 do begin
            vx:=(integer(pointer(longint(pntr)+i*4)^) and 65535);
            if vx>32767 then vx:=vx-65536;
            vx:=vx*getech div 51200;
            vy:=(integer(pointer(longint(pntr)+i*4+2)^) and 65535);
            if vy>32767 then vy:=vy-65536;
            vy:=vy*getech div 51200;
            x:=round(txdd-1+cos((i-180+colangle/5)*pi/360)*(0.5*getech+vx));
            y:=round(tydd-1+sin((i-180+colangle/5)*pi/360)*(0.5*getech+vx));
            lpset(x,y,col1,pfrom,1);
            x:=round(txdd-1-cos((i-180+colangle/5)*pi/360)*(0.5*getech+vy));
            y:=round(tydd-1-sin((i-180+colangle/5)*pi/360)*(0.5*getech+vy));
            lpset(x,y,col2,pfrom,1);
          end;
        end;
      end;

      vx:=round(cos(ab*pi/1800)*sin(ab*pi/1800)*0.5*getech);
      vy:=round(sin(ab*pi/1800)*0.5*getech);
      for i:=1 to 50*getech div 100 do begin
       lpset(field[i].x+vx,field[i].y+vy,col7,pfrom,1);
      end;

      x:=round(cos(ab*pi/1800)*cos(ab*pi/1800)*1.5*getech);
      y:=round(sin(ab*pi/1800)*cos(ab*pi/1800+800)*1.5*getech);
      lpset(x+txdd-1+vx,y+tydd-1+vy,col4,pfrom,2);

      x:=round(cos((ab+1200)*pi/1800)*cos(ab*pi/1800+900)*1.5*getech);
      y:=round(sin((ab+1200)*pi/1800)*cos(ab*pi/1800+700)*1.5*getech);
      lpset(x+txdd-1+vx,y+tydd-1+vy,col5,pfrom,2);

      x:=round(cos((ab+2400)*pi/1800)*cos(ab*pi/1800+100)*1.5*getech);
      y:=round(sin((ab+2400)*pi/1800)*cos(ab*pi/1800+750)*1.5*getech);
      lpset(x+txdd-1+vx,y+tydd-1+vy,col6,pfrom,2);

      ab:=(ab+5) mod 3600;
    end;
    (*cube*)
    3,7:begin
      ltpset(txdd-1,tydd-1,pfrom,1);
      ptable:=table2;
      toscreen:=screen3;
      bitmap.bmp:=screen3;
      performcube(cube,world,bitmap);
      world.a1:=(world.a1+5) mod 3600;
      world.a2:=(world.a2-2) mod 3600;
      world.a3:=(world.a3+1) mod 3600;
      l:=txd*tyd;
      asm
        pushad
        mov ecx,l
        mov esi, pfrom
        mov edi, screen3
        rep movsd
        popad
      end;

      if (PMod.getmod(21)=1) and (pmod.getmod(12)=1) then begin
        pntr:=ptr(PMod.getmod(20)+((PMod.getmod(17) shr (tai+2)) shl (tai+2)));
        if pntr<>nil then begin
          for i:=0 to 359 do begin
            vx:=(integer(pointer(longint(pntr)+i*4)^) and 65535);
            if vx>32767 then vx:=vx-65536;
            vx:=vx*getech div (51200*2);
            vy:=(integer(pointer(longint(pntr)+i*4+2)^) and 65535);
            if vy>32767 then vy:=vy-65536;
            vy:=vy*getech div (51200*2);
            x:=round(txdd-1+cos((i-180+colangle/5)*pi/360)*(0.2*getech+vx));
            y:=round(tydd-1+sin((i-180+colangle/5)*pi/360)*(0.2*getech+vx));
            lpset(x,y,col1,pfrom,1);
            x:=round(txdd-1-cos((i-180+colangle/5)*pi/360)*(0.2*getech+vy));
            y:=round(tydd-1-sin((i-180+colangle/5)*pi/360)*(0.2*getech+vy));
            lpset(x,y,col5,pfrom,1);
          end;
        end;
      end;


      if show=7 then begin
        drawback(cube,bitmap,(col1+col5) div 2,64);
        drawfront(cube,bitmap,(col1+col5) div 2,256);
      end else begin
        drawtrans(cube,bitmap,(col1+col5) div 2,64);
      end;
    end;
  end;

  l:=txd*tyd;
  case txd of
    128:asm
      pushad
      mov esi, ptable
      mov edi, pto
      mov ecx, l
@lp:
      mov ebx, [esi+ecx*4-4]
      add ebx, pfrom
      mov eax, [ebx]
      mov edx, [ebx-128*4]
      add eax, [ebx-1*4]
      add edx, [ebx+129*4]
      add eax, edx
      shr eax, 2
      and eax, andval
      mov [edi+ecx*4-4], eax
      dec ecx
      jnz @lp
      popad
    end;
    320:asm
      pushad
      mov esi, ptable
      mov edi, pto
      mov ecx, l
@lp:
      mov ebx, [esi+ecx*4-4]
      add ebx, pfrom
      mov eax, [ebx]
      mov edx, [ebx-320*4]
      add eax, [ebx-1*4]
      add edx, [ebx+321*4]
      add eax, edx
      shr eax, 2
      and eax, andval
      mov [edi+ecx*4-4], eax
      dec ecx
      jnz @lp
      popad
    end;
    400:asm
      pushad
      mov esi, ptable
      mov edi, pto
      mov ecx, l
@lp:
      mov ebx, [esi+ecx*4-4]
      add ebx, pfrom
      mov eax, [ebx]
      mov edx, [ebx-400*4]
      add eax, [ebx-1*4]
      add edx, [ebx+401*4]
      add eax, edx
      shr eax, 2
      and eax, andval
      mov [edi+ecx*4-4], eax
      dec ecx
      jnz @lp
      popad
    end;
    512:asm
      pushad
      mov esi, ptable
      mov edi, pto
      mov ecx, l
@lp:
      mov ebx, [esi+ecx*4-4]
      add ebx, pfrom
      mov eax, [ebx]
      mov edx, [ebx-512*4]
      add eax, [ebx-1*4]
      add edx, [ebx+513*4]
      add eax, edx
      shr eax, 2
      and eax, andval
      mov [edi+ecx*4-4], eax
      dec ecx
      jnz @lp
      popad
    end;
    640:asm
      pushad
      mov esi, ptable
      mov edi, pto
      mov ecx, l
@lp:
      mov ebx, [esi+ecx*4-4]
      add ebx, pfrom
      mov eax, [ebx]
      mov edx, [ebx-640*4]
      add eax, [ebx-1*4]
      add edx, [ebx+641*4]
      add eax, edx
      shr eax, 2
      and eax, andval
      mov [edi+ecx*4-4], eax
      dec ecx
      jnz @lp
      popad
    end;
  end;
  nop:
  (*transfert vers l'cran*)
  if mode<4 then begin
    l:=txd*tyd;
    asm
      pushad
      mov esi, toscreen
      mov edi, pbitmap
      mov ecx, l
      cld
      rep movsd
      popad
    end;
    bitblt(hn,0,0,txd,tyd,H,(txd-oldtx) div 2,(tyd-oldty) div 2,SRCCOPY);
{$IFDEF DDraw}
  end else begin
    surfacedesc.dwSize:=sizeof(surfacedesc);
    if surface.lock(nil,surfacedesc,DDLOCK_WRITEONLY,0)<>dd_ok then begin
      uninitv;
      waitingforreinit:=true;
      exit;
    end;
    i:=surfacedesc.lPitch;
    sb:=txd*4;
    case bpp of
      32:begin
        asm
          pushad
          mov esi, toscreen
          mov edi, surfacedesc.lpsurface
          mov ebx, tyd
@lp:
          mov ecx, txd
@line:
          mov eax, [esi+ecx*4-4]
          mov [edi+ecx*4-4],eax
          dec ecx
          jnz @line

          add esi, sb
          add edi, i
          dec ebx
          jnz @lp
          popad
        end;
      end;
      16:begin
        asm
          pushad
          mov esi, toscreen
          mov edi, surfacedesc.lpsurface
          mov ebx, tyd
@lp:
          mov ecx, txd
@line:
          mov eax, [esi+ecx*4-4]
          ror eax, 8
          shr ah, 3
          shr ax, 2
          rol eax, 5
          mov [edi+ecx*2-2],ax
          dec ecx
          jnz @line

          add esi, sb
          add edi, i
          dec ebx
          jnz @lp
          popad
        end;
      end;
    end;
    if surface.Unlock(surfacedesc.lpsurface)<>dd_ok then begin
      uninitv;
      waitingforreinit:=true;
      exit;
    end;
{$ENDIF}
  end;
  temp:=pimg1;
  pimg1:=pimg2;
  pimg2:=temp;
end;

{$IFDEF DDraw}
procedure onfull(Sender:TObject);
begin
  uninitv;
  initv(0,resx[resindex],resy[resindex],true);
end;

procedure onres1(Sender:TObject);
begin
  myform.res1.checked:=true;
  resindex:=0;
end;

procedure onres2(Sender:TObject);
begin
  myform.res2.checked:=true;
  resindex:=1;
end;

procedure onres3(Sender:TObject);
begin
  myform.res3.checked:=true;
  resindex:=2;
end;

procedure onres4(Sender:TObject);
begin
  myform.res4.checked:=true;
  resindex:=3;
end;

procedure onres5(Sender:TObject);
begin
  myform.res5.checked:=true;
  resindex:=4;
end;

procedure onres6(Sender:TObject);
begin
  myform.res6.checked:=true;
  resindex:=5;
end;
{$ENDIF}

procedure visinit;
begin
{$IFDEF DDraw}
  ddform:=tform.create(application);
  ddform.borderstyle:=bsnone;
  myform.form:=tform.create(application);
  myform.popup:=tpopupmenu.create(myform.form);
  myform.full:=tmenuitem.create(myform.popup);
  myform.res1:=tmenuitem.create(myform.popup);
  myform.res2:=tmenuitem.create(myform.popup);
  myform.res3:=tmenuitem.create(myform.popup);
  myform.res4:=tmenuitem.create(myform.popup);
  myform.res5:=tmenuitem.create(myform.popup);
  myform.res6:=tmenuitem.create(myform.popup);
  myform.nil1:=tmenuitem.create(myform.popup);
  myform.full.caption:='Full screen';
  @myform.full.onclick:=@onfull;
  myform.res1.caption:='320x200';
  @myform.res1.onclick:=@onres1;
  myform.res2.caption:='320x240';
  @myform.res2.onclick:=@onres2;
  myform.res3.caption:='400x300';
  @myform.res3.onclick:=@onres3;
  myform.res4.caption:='512x384';
  @myform.res4.onclick:=@onres4;
  myform.res5.caption:='640x400';
  @myform.res5.onclick:=@onres5;
  myform.res6.caption:='640x480';
  @myform.res6.onclick:=@onres6;
  myform.nil1.caption:='-';
  resindex:=0;
  myform.res1.radioitem:=true;
  myform.res2.radioitem:=true;
  myform.res3.radioitem:=true;
  myform.res4.radioitem:=true;
  myform.res5.radioitem:=true;
  myform.res6.radioitem:=true;
  loadreg;
  case resindex of
    0:myform.res1.checked:=true;
    1:myform.res2.checked:=true;
    2:myform.res3.checked:=true;
    3:myform.res4.checked:=true;
    4:myform.res5.checked:=true;
    5:myform.res6.checked:=true;
  end;

  myform.popup.autopopup:=false;
  myform.popup.items.add(myform.full);
  myform.popup.items.add(myform.nil1);
  myform.popup.items.add(myform.res1);
  myform.popup.items.add(myform.res2);
  myform.popup.items.add(myform.res3);
  myform.popup.items.add(myform.res4);
  myform.popup.items.add(myform.res5);
  myform.popup.items.add(myform.res6);
{$ENDIF}
  waitingforreinit:=false;
  init:=false;
  randomize;
  show:=random(8);
  delai:=20;
  lv:=0;


  inittitre;

end;

procedure visuninit;
begin
{$IFDEF DDraw}
  ddform.release;
  myform.form.release;
  savereg;
{$ENDIF}
end;

procedure setupv;
{$IFDEF DDraw}
var m:tmouse;
{$ENDIF}
begin
{$IFDEF DDraw}
  m:=tmouse.create;
  myform.popup.Popup(m.cursorpos.x,m.cursorpos.y);
  m.free;
{$ENDIF}
end;

end.


