unit vispattern;

interface
uses windows,
     skin;

Var NChan:LongWord;

procedure clearpatt(hn:hwnd);
procedure initpatt(hn:hwnd;tx,ty:LongWord);
procedure UnInitPatt;
procedure DoPatt(hn:hwnd;pos:byte;pl:boolean;pmod:tpmod);

implementation

{$i fonts.pas}

Var PattOldImage,PattImage,PattH:HWnd;
Var PattPBitmap:Pointer;
Var PattBackImage:Pointer;
Var Txp,Typ,NLin,PLin:LongWord;

Function CreateDIBSection(hdc:hwnd;bit:pointer;usage:word;pnt:pointer;truc:hwnd;machin:longword):hwnd;stdcall
external 'gdi32.dll' name 'CreateDIBSection';

function hex(b,l:byte;z:boolean):Shortstring;
Const HexTab='0123456789ABCDEF';
begin
  if l=2 then begin
    hex:=hextab[1+b shr 4]+hextab[1+b and $f];
    if z and (b=0) then hex:='--';
  end else begin
    hex:=hextab[1+b and $f];
    if z and (b=0) then hex:='-';
  end;
end;

procedure text(pnt:pointer;offs:longword;stri:pointer;size:word;ret:longword;col:byte;fnt:pointer);
begin
    asm
      pushad
      mov cx, size
      mov dl, col
@lpf:
      push cx
      mov edi, pnt
      add edi, offs
      mov ebx, stri
      inc stri

      xor eax, eax
      mov al, [ebx]
      shl eax, 4
      mov esi, fnt
      add esi, eax
      mov cx, 5
@lp:
        cmp byte ptr [esi], 0
        jz @np1
        mov [edi], dl
@np1:
        cmp byte ptr [esi+1], 0
        jz @np2
        mov [edi+1], dl
@np2:
        cmp byte ptr [esi+2], 0
        jz @np3
        mov [edi+2], dl
@np3:
        add edi, ret
        add esi, 3
        dec cx
        jnz @lp
      add offs, 3
    pop cx
    dec cx
    jnz @lpf
    popad
  end;
end;

procedure clearpatt(hn:hwnd);
begin
  move(pattbackimage^,pattpbitmap^,txp*typ);
  bitblt(hn,0,0,txp,typ,pattH,0,0,SRCCOPY);
end;

procedure initpatt(hn:hwnd;tx,ty:LongWord);
type tbi=record
  bmiHeader:bitmapinfoheader;
  bmiColors:array[0..255] of rgbquad;
end;

Var bminfo:tbi;
var w:longword;
    i,j:word;
begin
  txp:=tx;
  typ:=ty;
  nchan:=(tx-12) div (16*3);
  plin:=(ty-2) div 7;
  plin:=(plin-1) div 2;
  nlin:=plin*2+1;
  bminfo.bmiHeader.bisize:=sizeof(tagBITMAPINFOHEADER);
  bminfo.bmiHeader.biwidth:=txp;
  bminfo.bmiHeader.biheight:=-typ;
  bminfo.bmiHeader.biplanes:=1;
  bminfo.bmiHeader.biBitCount:=8;
  bminfo.bmiHeader.bicompression:=bi_rgb;
  bminfo.bmiHeader.bisizeimage:=0;
  bminfo.bmiHeader.biXPelsPerMeter:=0;
  bminfo.bmiHeader.biYPelsPerMeter:=0;
  bminfo.bmiHeader.biclrused:=0;
  bminfo.bmiHeader.biClrImportant:=0;

  for i:=0 to 15 do begin
    bminfo.bmicolors[i].rgbred:=  ((i shr 3)*21+((i and 4) shr 2)*42)*3;
    bminfo.bmicolors[i].rgbgreen:=((i shr 3)*21+((i and 2) shr 1)*42)*0;
    bminfo.bmicolors[i].rgbblue:= ((i shr 3)*21+((i and 1) shr 0)*42)*3;
  end;
  bminfo.bmicolors[254].rgbred:=240;
  bminfo.bmicolors[254].rgbgreen:=220;
  bminfo.bmicolors[254].rgbblue:=0;
  bminfo.bmicolors[255].rgbred:=$ff;
  bminfo.bmicolors[255].rgbgreen:=$ff;
  bminfo.bmicolors[255].rgbblue:=$ff;

  patth:=CreateCompatibleDC(hn);
  pattimage:=createdibsection(0,@bminfo,DIB_RGB_COLORS,@pattpbitmap,0,0);
  pattoldimage:=selectobject(patth,pattimage);

  getmem(pattbackimage,txp*typ);
  fillchar(pattbackimage^,txp*typ,0);
  for w:=(1+plin*7)*txp to (8+plin*7)*txp-1 do
    byte(pointer(longword(pattbackimage)+w)^):=7;
  for i:=0 to nchan-1 do begin
    j:=i*16*3+11;
    for w:=0 to nlin*7+2 do begin
      byte(pointer(longword(pattbackimage)+j+w*txp+0)^):=7;
      byte(pointer(longword(pattbackimage)+j+w*txp+1)^):=15;
      byte(pointer(longword(pattbackimage)+j+w*txp+2)^):=7;
      byte(pointer(longword(pattbackimage)+j+w*txp+3)^):=8;
    end;
  end;
  clearpatt(hn);
end;

procedure UnInitPatt;
begin
  freemem(pattbackimage);
  selectobject(patth,pattoldimage);
  deleteobject(pattimage);
  deletedc(patth);
end;

procedure DoPatt(hn:hwnd;pos:byte;pl:boolean;pmod:tpmod);
var pt:pointer;

Var I,T,Chan:Byte;
    Note:Integer;
    CNote,CPatt,CPos:Byte;
Var X:word;
Var Txt:ShortString;
Var Offs:LongWord;
Var MaxChan:Word;
Var U,V:LongWord;
Label Nop;
const col=254;
begin
  pt:=pattpbitmap;
  move(pattbackimage^,pt^,txp*typ);

  T:=PMod.GetMod(31);
  If (PMod.GetMod(24)<>0) Or Not Pl Then Goto Nop;

  CPatt:=PMod.GetMod(6);
  CNote:=PMod.GetMod(7);
  CPos:=PMod.GetMod(8);
  MaxChan:=PMod.GetMod(9)-1;
  If MaxChan>nchan-1 Then MaxChan:=nchan-1;

  Offs:=txp*2+3;
  For Note:=CNote-plin To CNote+plin Do Begin
    X:=0;
    If (Note<=PMod.GetPattern(CPos,0,0,6)) AND (Note>0) Then Begin
      Txt:=Hex(Note,2,False)+'   ';
      Text(pt,Offs,@txt[1],length(txt),txp,col,@font);
      Inc(X,length(txt)*3);
      Inc(Offs,length(txt)*3);


      For I:=0 To MaxChan Do Begin
        Chan:=I+Pos;
        Txt:=PMod.GetPatternS(CPatt,Note,Chan,1)+' ';

        Txt:=Txt+Hex(PMod.GetPattern(CPatt,Note,Chan,1),2,True)+' ';
        Txt:=Txt+Hex(PMod.GetPattern(CPatt,Note,Chan,5),2,True)+' ';
        U:=PMod.GetPattern(CPatt,Note,Chan,3);
        V:=PMod.GetPattern(CPatt,Note,Chan,4);
        If U+V=0 Then Txt:=Txt+'---' Else Begin
          If T<>2 Then Txt:=Txt+Hex(U,1,False) Else Txt:=Txt+Chr(U+64);
          Txt:=Txt+Hex(V,2,False);
        End;
        Txt:=Txt+'   ';
        inc(x,length(txt)*3);
        Text(pt,offs,@txt[1],length(txt),txp,col,@font);
        inc(offs,length(txt)*3);

      End;
    End;
    inc(offs, 7*txp-x);
  End;
nop:
  bitblt(hn,0,0,txp,typ,pattH,0,0,SRCCOPY);
end;

end.
